!/*
! * SocketTools Library Edition
! * Version 3.0
! *
! * Copyright 1995-1999, Catalyst Development Corporation
! * All rights reserved
! *
! * This module contains the confidential and proprietary information
! * of Catalyst Development Corporation and may not be redistributed.
! *
! * This product is licensed to you pursuant to the terms of the
! * Catalyst license agreement included with the original software,
! * and is protected by copyright law and international treaties.
! * Unauthorized reproduction or distribution may result in severe
! * criminal penalties.
! */

!***************************************************************************
! Notes for the Clarion Conversion
!
! This document is being distributed with the permission of
! Catalyst Development Corporation.
!
! The C prototypes have been left in place for reference in debugging
! and to facilitate the learning process for those Clarion programmers
! who are unfamiliar with C.
!
! Each block of prototypes begins with the commented C version, followed
! by the Clarion prototypes
!
! The proverbial disclaimer:
! This C to CW conversion is being offered as service to the Clarion
! developer community. As such, none of the contributors make any assurance
! that this code will work for you. There may be errors and omissions. If
! you find an error or omission, you are encouraged to submitt your *tested*
! fix for inclusion in a future release.
!
! Initial conversion to Clarion by: Mark Geisinger
! POP3 courtesy of Greg Palmer by way of Jeff Slarve
! Comments or corrections may be sent to: critters@bugsbugme.com
! Initial public release:   09/20/1998
! Updated:                  09/22/1998
!    Added the cstools_readme.txt file. See that file for release notes and
!    usage information.
!***************************************************************************

!#ifndef _CSTOOLS_CSPROTO_H
!#define _CSTOOLS_CSPROTO_H

!#if !defined(RC_INVOKED)
!#if !defined(__MKTYPLIB__) && !defined(__midl)

!#ifdef __cplusplus
!extern "C" {
!#endif

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * audio libraries CSAUDL16.DLL and CSAUDL32.DLL
! *
! *************************************************************************/

!PUBLIC VOID WINAPI SetLastAudioError(int);
!PUBLIC int WINAPI GetLastAudioError(VOID);
!PUBLIC int WINAPI CancelAudioPlayback(VOID);

!#ifdef WIN32
!PUBLIC int WINAPI GetAudioErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI GetAudioErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define GetAudioErrorString GetAudioErrorStringW
!#else
!#define GetAudioErrorString GetAudioErrorStringA
!#endif

!PUBLIC UINT WINAPI GetAudioFileFormatW(LPCWSTR);
!PUBLIC UINT WINAPI GetAudioFileFormatA(LPCSTR);
!#ifdef UNICODE
!#define GetAudioFileFormat GetAudioFileFormatW
!#else
!#define GetAudioFileFormat GetAudioFileFormatA
!#endif

!PUBLIC int WINAPI ConvertAudioFileW(LPCWSTR, UINT, LPCWSTR, UINT);
!PUBLIC int WINAPI ConvertAudioFileA(LPCSTR, UINT, LPCSTR, UINT);
!#ifdef UNICODE
!#define ConvertAudioFile ConvertAudioFileW
!#else
!#define ConvertAudioFile ConvertAudioFileA
!#endif

!PUBLIC int WINAPI PlayAudioFileW(LPCWSTR);
!PUBLIC int WINAPI PlayAudioFileA(LPCSTR);
!#ifdef UNICODE
!#define PlayAudioFile PlayAudioFileW
!#else
!#define PlayAudioFile PlayAudioFileA
!#endif

!#else /* !WIN32 */

!PUBLIC int WINAPI GetAudioErrorString(int, LPSTR, int);
!PUBLIC UINT WINAPI GetAudioFileFormat(LPCSTR);
!PUBLIC int WINAPI ConvertAudioFile(LPCSTR, UINT, LPCSTR, UINT);
!PUBLIC int WINAPI PlayAudioFile(LPCSTR);

!#endif /* WIN32 */

Section('SocketTools Audio')
    Map
        Module('CSAUDL32.DLL')
            SetLastAudioError(Signed),raw,c,dll
            GetLastAudioError(), Signed, Pascal
            CancelAudioPlayback(), Signed, Pascal
            Compile('***', _WIDTH32_)
                GetAudioErrorString( Signed, *CString, Signed ), Signed, Raw, Pascal, Name('GetAudioErrorStringA')
                GetAudioFileFormat( *CString ), Unsigned, Raw, Pascal, Name('GetAudioFileFormatA')
                ConvertAudioFile( *CString, Unsigned, *CString, Unsigned ), Raw, Pascal, Name('ConvertAudioFileA')
                PlayAudioFile(*CString ), Signed, Raw, Pascal, Name('PlayAudioFileA')
            ***
            Omit('***', _WIDTH32_)
                GetAudioErrorString( Signed, *CString, Signed ), Signed, Raw, Pascal
                GetAudioFileFormat( *CString ), Unsigned, Raw, Pascal
                ConvertAudioFile( *CString, Unsigned, *CString, Unsigned ), Raw, Pascal
                PlayAudioFile(*CString ), Signed, Raw, Pascal
            ***
        end  ! Module('SocketTools Audio Library') 


!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Domain Name Service (DNS) client libraries CSDNSL16.DLL and
! * CSDNSL32.DLL
! *
! ************************************************************************/

!PUBLIC VOID WINAPI DnsSetLastError(int);
!PUBLIC int WINAPI DnsGetLastError();
!PUBLIC int WINAPI DnsDisconnect(HCLIENT);
!PUBLIC SOCKET WINAPI DnsGetSocket(HCLIENT);
!PUBLIC int WINAPI DnsUnregisterServer(HCLIENT, int);
!PUBLIC DWORD WINAPI DnsGetServerAddress(HCLIENT, int);
!PUBLIC int WINAPI DnsGetServerPort(HCLIENT, int);
!PUBLIC int WINAPI DnsReset(HCLIENT);
!PUBLIC int WINAPI DnsCancel(HCLIENT);
!PUBLIC int WINAPI DnsSetTimeout(HCLIENT, int);
!PUBLIC int WINAPI DnsGetTimeout(HCLIENT);
!PUBLIC DWORD WINAPI DnsGetResolverAddress(HCLIENT);
!PUBLIC int WINAPI DnsSetRetryCount(HCLIENT, int);
!PUBLIC int WINAPI DnsGetRetryCount(HCLIENT);
!PUBLIC VOID WINAPI DnsUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI DnsInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI DnsInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define DnsInitialize DnsInitializeW
!#else
!#define DnsInitialize DnsInitializeA
!#endif

!PUBLIC int WINAPI DnsGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI DnsGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define DnsGetErrorString DnsGetErrorStringW
!#else
!#define DnsGetErrorString DnsGetErrorStringA
!#endif

!PUBLIC HCLIENT WINAPI DnsConnectW(LPCWSTR, int, int, int);
!PUBLIC HCLIENT WINAPI DnsConnectA(LPCSTR, int, int, int);
!#ifdef UNICODE
!#define DnsConnect DnsConnectW
!#else
!#define DnsConnect DnsConnectA
!#endif

!PUBLIC int WINAPI DnsRegisterServerW(HCLIENT, int, LPCWSTR, int);
!PUBLIC int WINAPI DnsRegisterServerA(HCLIENT, int, LPCSTR, int);
!#ifdef UNICODE
!#define DnsRegisterServer DnsRegisterServerW
!#else
!#define DnsRegisterServer DnsRegisterServerA
!#endif

!PUBLIC int WINAPI DnsSetLocalDomainW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI DnsSetLocalDomainA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define DnsSetLocalDomain DnsSetLocalDomainW
!#else
!#define DnsSetLocalDomain DnsSetLocalDomainA
!#endif

!PUBLIC int WINAPI DnsGetLocalDomainW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI DnsGetLocalDomainA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define DnsGetLocalDomain DnsGetLocalDomainW
!#else
!#define DnsGetLocalDomain DnsGetLocalDomainA
!#endif

!PUBLIC LPHOSTENT WINAPI DnsGetHostByNameA(HCLIENT, LPCSTR);
!#ifndef UNICODE
!#define DnsGetHostByName DnsGetHostByNameA
!#endif

!PUBLIC LPHOSTENT WINAPI DnsGetHostByAddressA(HCLIENT, LPVOID, int, int);
!#ifndef UNICODE
!#define DnsGetHostByAddress DnsGetHostByAddressA
!#endif

!PUBLIC int WINAPI DnsGetHostInfoW(HCLIENT, LPCWSTR, LPWSTR, int);
!PUBLIC int WINAPI DnsGetHostInfoA(HCLIENT, LPCSTR, LPSTR, int);
!#ifdef UNICODE
!#define DnsGetHostInfo DnsGetHostInfoW
!#else
!#define DnsGetHostInfo DnsGetHostInfoA
!#endif

!PUBLIC int WINAPI DnsGetHostServicesW(HCLIENT, LPCWSTR, int, LPWSTR, int);
!PUBLIC int WINAPI DnsGetHostServicesA(HCLIENT, LPCSTR, int, LPSTR, int);
!#ifdef UNICODE
!#define DnsGetHostServices DnsGetHostServicesW
!#else
!#define DnsGetHostServices DnsGetHostServicesA
!#endif

!PUBLIC int WINAPI DnsGetMailExchangeW(HCLIENT, LPCWSTR, LPINT, LPWSTR, int);
!PUBLIC int WINAPI DnsGetMailExchangeA(HCLIENT, LPCSTR, LPINT, LPSTR, int);
!#ifdef UNICODE
!#define DnsGetMailExchange DnsGetMailExchangeW
!#else
!#define DnsGetMailExchange DnsGetMailExchangeA
!#endif

!PUBLIC int WINAPI DnsGetRecordW(HCLIENT, LPCWSTR, int, LPWSTR, int);
!PUBLIC int WINAPI DnsGetRecordA(HCLIENT, LPCSTR, int, LPSTR, int);
!#ifdef UNICODE
!#define DnsGetRecord DnsGetRecordW
!#else
!#define DnsGetRecord DnsGetRecordA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI DnsInitialize(LPCSTR, DWORD);
!PUBLIC int WINAPI DnsGetErrorString(int, LPSTR, int);
!PUBLIC HCLIENT WINAPI DnsConnect(LPCSTR, int, int, int);
!PUBLIC int WINAPI DnsRegisterServer(HCLIENT, int, LPCSTR, int);
!PUBLIC int WINAPI DnsSetLocalDomain(HCLIENT, LPCSTR);
!PUBLIC int WINAPI DnsGetLocalDomain(HCLIENT, LPSTR, int);
!PUBLIC LPHOSTENT WINAPI DnsGetHostByName(HCLIENT, LPCSTR);
!PUBLIC LPHOSTENT WINAPI DnsGetHostByAddress(HCLIENT, LPVOID, int, int);
!PUBLIC int WINAPI DnsGetHostInfo(HCLIENT, LPCSTR, LPSTR, int);
!PUBLIC int WINAPI DnsGetHostServices(HCLIENT, LPCSTR, int, LPSTR, int);
!PUBLIC int WINAPI DnsGetMailExchange(HCLIENT, LPCSTR, LPINT, LPSTR, int);
!PUBLIC int WINAPI DnsGetRecord(HCLIENT, LPCSTR, int, LPSTR, int);

!#endif /* WIN32 */

Section('SocketTools DNS')

        Module('CSDNSL32.DLL')

            DnsSetLastError(Signed), Pascal
            DnsGetLastError(), Signed, Pascal
            DnsGetLastError(HCLIENT), Signed, Pascal
            DnsDisconnect(HCLIENT), Signed, Pascal
            DnsGetSocket(HCLIENT), Socket, Pascal
            DnsUnregisterServer(HCLIENT, Signed), Signed, Pascal
            DnsGetServerAddress(HCLIENT, Signed), ulong, Pascal
            DnsGetServerPort(HCLIENT, Signed), Signed, Pascal
            DnsResetClient(HCLIENT), Signed, Pascal
            DnsCancelQuery(HCLIENT), Signed, Pascal
            DnsSetTimeout(HCLIENT, Signed), Signed, Pascal
            DnsGetTimeout(HCLIENT), Signed, Pascal
            DnsSetRetryCount(HCLIENT, Signed), Signed, Pascal
            DnsGetRetryCount(HCLIENT), Signed, Pascal
            DnsQueryServerAddress(HCLIENT), ulong, Pascal
            DnsUninitialize(),Pascal
            Compile('***', _WIDTH32_)
                DnsInitialize(*CString, ulong), BOOL, RAW, Pascal, Name('DnsInitializeA')
                DnsGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('DnsGetErrorStringA')
                DnsConnect(*CString, Signed, Signed, Signed), ulong, Raw, Pascal, Name('DnsConnectA')
                DnsRegisterServer(HCLIENT, Signed, *CString, Signed), Signed, Raw, Pascal, Name('DnsRegisterServerA')
                DnsSetLocalDomain(HCLIENT, *CString), Signed, Raw, Pascal, Name('DnsSetLocalDomainA')
                DnsGetLocalDomain(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('DnsGetLocalDomainA')
                DnsGetHostByName(HCLIENT, *CString), LPHOSTENT, Raw, Pascal, Name('DnsGetHostByNameA')
                DnsGetHostByAddress(HCLIENT, LPVOID, Signed, Signed),LPHOSTENT,Raw,Pascal, Name('DnsGetHostByAddressA')
                DnsGetHostInfo(HCLIENT, *CString, *CString, Signed), Signed, Raw, Pascal, Name('DnsGetHostInfoA')
                DnsGetHostServices(HCLIENT, *CString, Signed, *CString, Signed), Signed, Raw, Pascal, Name('DnsGetHostServicesA')
                DnsGetMailExchange(HCLIENT, *CString, LPINT, *CString, Signed), Signed, Raw, Pascal, Name('DnsGetMailExchangeA')
                DnsGetRecord(HCLIENT, *CString, Signed, *CString, Signed), Signed, Raw, Pascal, Name('DnsGetRecordA')
            ***
            Omit('***', _WIDTH32_)
                DnsInitialize(*CString, DWORD), BOOL, RAW, Pascal
                DnsGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
                DnsConnect(*CString, Signed, Signed, Signed), HCLIENT, Raw, Pascal
                DnsRegisterServer(HCLIENT, Signed, *CString, Signed), Signed, Raw, Pascal
                DnsSetLocalDomain(HCLIENT, *CString), Signed, Raw, Pascal
                DnsGetLocalDomain(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                DnsGetHostByName(HCLIENT, *CString), *HOSTENT, Raw, Pascal
                DnsGetHostByAddress(HCLIENT, LPVOID, Signed, Signed),*HOSTENT,Raw,Pascal
                DnsGetHostInfo(HCLIENT, *CString, *CString, Signed), Signed, Raw, Pascal
                DnsGetHostServices(HCLIENT, *CString, Signed, *CString, Signed), Signed, Raw, Pascal
                DnsGetMailExchange(HCLIENT, *CString, LPINT, *CString, Signed), Signed, Raw, Pascal
                DnsGetRecord(HCLIENT, *CString, Signed, *CString, Signed), Signed, Raw, Pascal
            ***
        end   ! Module('SocketTools Domain Name Service (DNS) client Library')


!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Finger client libraries CSFGRL16.DLL and CSFGRL32.DLL
! *
! ************************************************************************/

!PUBLIC int WINAPI FingerDisconnect(HCLIENT);
!PUBLIC int WINAPI FingerAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC int WINAPI FingerRead(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI FingerCancel(HCLIENT);
!PUBLIC int WINAPI FingerGetTimeout(HCLIENT);
!PUBLIC int WINAPI FingerSetTimeout(HCLIENT, int);
!PUBLIC BOOL WINAPI FingerIsBlocking(HCLIENT);
!PUBLIC VOID WINAPI FingerSetLastError(int);
!PUBLIC int WINAPI FingerGetLastError();
!PUBLIC SOCKET WINAPI FingerGetSocket(HCLIENT);
!PUBLIC VOID WINAPI FingerUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI FingerInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI FingerInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define FingerInitialize FingerInitializeW
!#else
!#define FingerInitialize FingerInitializeA
!#endif

!PUBLIC HCLIENT WINAPI FingerAsyncConnectW(LPCWSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI FingerAsyncConnectA(LPCSTR, UINT, UINT, HWND, UINT);
!#ifdef UNICODE
!#define FingerAsyncConnect FingerAsyncConnectW
!#else
!#define FingerAsyncConnect FingerAsyncConnectA
!#endif

!PUBLIC HCLIENT WINAPI FingerConnectW(LPCWSTR, UINT, UINT);
!PUBLIC HCLIENT WINAPI FingerConnectA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define FingerConnect FingerConnectW
!#else
!#define FingerConnect FingerConnectA
!#endif

!PUBLIC int WINAPI FingerUserW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FingerUserA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FingerUser FingerUserW
!#else
!#define FingerUser FingerUserA
!#endif

!PUBLIC int WINAPI FingerGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI FingerGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define FingerGetErrorString FingerGetErrorStringW
!#else
!#define FingerGetErrorString FingerGetErrorStringA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI FingerInitialize(LPCSTR, DWORD);
!PUBLIC HCLIENT WINAPI FingerAsyncConnect(LPCSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI FingerConnect(LPCSTR, UINT, UINT);
!PUBLIC int WINAPI FingerUser(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FingerGetErrorString(int, LPSTR, int);

!#endif /* WIN32 */

Section('SocketTools Finger')

        Module('CSFGRL32.DLL')
            FingerDisconnect(HCLIENT), Signed, Pascal
            FingerAsyncNotify(HCLIENT, HWND, Unsigned), Signed, Pascal
            FingerRead(HCLIENT, LPBYTE, Signed), Signed, Pascal
            FingerCancel(HCLIENT), Signed, Pascal
            FingerGetTimeout(HCLIENT), Signed, Pascal
            FingerSetTimeout(HCLIENT, Signed), Signed, Pascal
            FingerIsBlocking(HCLIENT), BOOL, Pascal
            FingerSetLastError(Signed), Pascal
            FingerGetLastError(), Signed, Pascal
            FingerGetSocket(HCLIENT), Socket, Pascal
            FingerUninitialize(), Pascal
            Compile('***', _WIDTH32_)
                FingerInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('FingerInitializeA')
                FingerAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HClient, Raw, Pascal, Name('FingerAsyncConnectA')
                FingerConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal, Name('FingerConnectA')
                FingerUser(HCLIENT, *CString), Signed, Raw, Pascal, Name('FingerUserA')
                FingerGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('FingerGetErrorStringA')
            ***
            Omit('***', _WIDTH32_)
                FingerInitialize(*CString, DWORD), BOOL, Raw, Pascal
                FingerAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HClient, Raw, Pascal
                FingerConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal
                FingerUser(HCLIENT, *CString), Signed, Raw, Pascal
                FingerGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
            ***
        end   ! Module('SocketTools Finger Client Library')

! This section contains the prototypes for the SocketTools
! File Transfer Protocol (FTP) client libraries CSFTPL16.DLL
! and CSFTPL32.DLL

!PUBLIC VOID WINAPI FtpSetLastError(int);
!PUBLIC int WINAPI FtpGetLastError(VOID);
!PUBLIC int WINAPI FtpDisconnect(HCLIENT);
!PUBLIC SOCKET WINAPI FtpGetSocket(HCLIENT);
!PUBLIC int WINAPI FtpCloseFile(HCLIENT);
!PUBLIC int WINAPI FtpEndOfFile(HCLIENT);
!PUBLIC int WINAPI FtpRead(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI FtpWrite(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI FtpGetResultCode(HCLIENT);
!PUBLIC int WINAPI FtpAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC int WINAPI FtpReset(HCLIENT);
!PUBLIC int WINAPI FtpCancel(HCLIENT);
!PUBLIC int WINAPI FtpIsBlocking(HCLIENT);
!PUBLIC int WINAPI FtpLogout(HCLIENT);
!PUBLIC int WINAPI FtpSetFileType(HCLIENT, UINT);
!PUBLIC int WINAPI FtpSetFileStructure(HCLIENT, UINT);
!PUBLIC int WINAPI FtpSetFileMode(HCLIENT, UINT);
!PUBLIC int WINAPI FtpSetPassiveMode(HCLIENT, BOOL);
!PUBLIC int WINAPI FtpAllocate(HCLIENT, DWORD, DWORD);
!PUBLIC int WINAPI FtpChangeDirectoryUp(HCLIENT);
!PUBLIC DWORD WINAPI FtpGetBytesCopied(HCLIENT);
!PUBLIC DWORD WINAPI FtpGetTransferTime(HCLIENT);
!PUBLIC int WINAPI FtpGetTimeout(HCLIENT);
!PUBLIC int WINAPI FtpSetTimeout(HCLIENT, int);
!PUBLIC int WINAPI FtpRestart(HCLIENT, DWORD);
!PUBLIC VOID WINAPI FtpUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI FtpInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI FtpInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define FtpInitialize FtpInitializeW
!#else
!#define FtpInitialize FtpInitializeA
!#endif

!FtpInitialize   equate(FtpInitializeA)

!PUBLIC HCLIENT WINAPI FtpConnectW(LPCWSTR, UINT, UINT);
!PUBLIC HCLIENT WINAPI FtpConnectA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define FtpConnect FtpConnectW
!#else
!#define FtpConnect FtpConnectA
!#endif

!PUBLIC int WINAPI FtpGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI FtpGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define FtpGetErrorString FtpGetErrorStringW
!#else
!#define FtpGetErrorString FtpGetErrorStringA
!#endif

!PUBLIC int WINAPI FtpOpenFileW(HCLIENT, LPCWSTR, UINT);
!PUBLIC int WINAPI FtpOpenFileA(HCLIENT, LPCSTR, UINT);
!#ifdef UNICODE
!#define FtpOpenFile FtpOpenFileW
!#else
!#define FtpOpenFile FtpOpenFileA
!#endif

!PUBLIC int WINAPI FtpFileListW(HCLIENT, LPCWSTR, BOOL);
!PUBLIC int WINAPI FtpFileListA(HCLIENT, LPCSTR, BOOL);
!#ifdef UNICODE
!#define FtpFileList FtpFileListW
!#else
!#define FtpFileList FtpFileListA
!#endif

!PUBLIC int WINAPI FtpCommandW(HCLIENT, LPCWSTR, LPCWSTR);
!PUBLIC int WINAPI FtpCommandA(HCLIENT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define FtpCommand FtpCommandW
!#else
!#define FtpCommand FtpCommandA
!#endif

!PUBLIC int WINAPI FtpGetResultStringW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI FtpGetResultStringA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define FtpGetResultString FtpGetResultStringW
!#else
!#define FtpGetResultString FtpGetResultStringA
!#endif

!PUBLIC int WINAPI FtpGetFileLengthW(HCLIENT, LPCWSTR, LPDWORD);
!PUBLIC int WINAPI FtpGetFileLengthA(HCLIENT, LPCSTR, LPDWORD);
!#ifdef UNICODE
!#define FtpGetFileLength FtpGetFileLengthW
!#else
!#define FtpGetFileLength FtpGetFileLengthA
!#endif

!PUBLIC int WINAPI FtpRenameFileW(HCLIENT, LPCWSTR, LPCWSTR);
!PUBLIC int WINAPI FtpRenameFileA(HCLIENT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define FtpRenameFile FtpRenameFileW
!#else
!#define FtpRenameFile FtpRenameFileA
!#endif

!PUBLIC int WINAPI FtpRemoveFileW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FtpRemoveFileA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FtpRemoveFile FtpRemoveFileW
!#else
!#define FtpRemoveFile FtpRemoveFileA
!#endif

!PUBLIC int WINAPI FtpChangeDirectoryW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FtpChangeDirectoryA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FtpChangeDirectory FtpChangeDirectoryW
!#else
!#define FtpChangeDirectory FtpChangeDirectoryA
!#endif

!PUBLIC int WINAPI FtpGetDirectoryW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI FtpGetDirectoryA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define FtpGetDirectory FtpGetDirectoryW
!#else
!#define FtpGetDirectory FtpGetDirectoryA
!#endif

!PUBLIC int WINAPI FtpCreateDirectoryW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FtpCreateDirectoryA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FtpCreateDirectory FtpCreateDirectoryW
!#else
!#define FtpCreateDirectory FtpCreateDirectoryA
!#endif

!PUBLIC int WINAPI FtpRemoveDirectoryW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FtpRemoveDirectoryA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FtpRemoveDirectory FtpRemoveDirectoryW
!#else
!#define FtpRemoveDirectory FtpRemoveDirectoryA
!#endif

!PUBLIC int WINAPI FtpMountStructureW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FtpMountStructureA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FtpMountStructure FtpMountStructureW
!#else
!#define FtpMountStructure FtpMountStructureA
!#endif

!PUBLIC int WINAPI FtpGetSystemInfoW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI FtpGetSystemInfoA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define FtpGetSystemInfo FtpGetSystemInfoW
!#else
!#define FtpGetSystemInfo FtpGetSystemInfoA
!#endif

!PUBLIC int WINAPI FtpGetStatusW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI FtpGetStatusA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define FtpGetStatus FtpGetStatusW
!#else
!#define FtpGetStatus FtpGetStatusA
!#endif

!PUBLIC int WINAPI FtpGetFileW(HCLIENT, LPCWSTR, LPCWSTR, BOOL);
!PUBLIC int WINAPI FtpGetFileA(HCLIENT, LPCSTR, LPCSTR, BOOL);
!#ifdef UNICODE
!#define FtpGetFile FtpGetFileW
!#else
!#define FtpGetFile FtpGetFileA
!#endif

!PUBLIC int WINAPI FtpPutFileW(HCLIENT, LPCWSTR, LPCWSTR, BOOL);
!PUBLIC int WINAPI FtpPutFileA(HCLIENT, LPCSTR, LPCSTR, BOOL);
!#ifdef UNICODE
!#define FtpPutFile FtpPutFileW
!#else
!#define FtpPutFile FtpPutFileA
!#endif

!PUBLIC int WINAPI FtpUsernameW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FtpUsernameA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FtpUsername FtpUsernameW
!#else
!#define FtpUsername FtpUsernameA
!#endif

!PUBLIC int WINAPI FtpPasswordW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FtpPasswordA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FtpPassword FtpPasswordW
!#else
!#define FtpPassword FtpPasswordA
!#endif

!PUBLIC int WINAPI FtpAccountW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI FtpAccountA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define FtpAccount FtpAccountW
!#else
!#define FtpAccount FtpAccountA
!#endif

!PUBLIC int WINAPI FtpLoginW(HCLIENT, LPCWSTR, LPCWSTR, LPCWSTR);
!PUBLIC int WINAPI FtpLoginA(HCLIENT, LPCSTR, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define FtpLogin FtpLoginW
!#else
!#define FtpLogin FtpLoginA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI FtpInitialize(LPCSTR, DWORD);
!PUBLIC HCLIENT WINAPI FtpConnect(LPCSTR, UINT, UINT);
!PUBLIC int WINAPI FtpGetErrorString(int, LPSTR, int);
!PUBLIC int WINAPI FtpOpenFile(HCLIENT, LPCSTR, UINT);
!PUBLIC int WINAPI FtpFileList(HCLIENT, LPCSTR, BOOL);
!PUBLIC int WINAPI FtpCommand(HCLIENT, LPCSTR, LPCSTR);
!PUBLIC int WINAPI FtpGetResultString(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI FtpGetFileLength(HCLIENT, LPCSTR, LPDWORD);
!PUBLIC int WINAPI FtpRenameFile(HCLIENT, LPCSTR, LPCSTR);
!PUBLIC int WINAPI FtpRemoveFile(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FtpChangeDirectory(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FtpGetDirectory(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI FtpCreateDirectory(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FtpRemoveDirectory(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FtpMountStructure(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FtpGetSystemInfo(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI FtpGetStatus(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI FtpGetFile(HCLIENT, LPCSTR, LPCSTR, BOOL);
!PUBLIC int WINAPI FtpPutFile(HCLIENT, LPCSTR, LPCSTR, BOOL);
!PUBLIC int WINAPI FtpUsername(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FtpPassword(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FtpAccount(HCLIENT, LPCSTR);
!PUBLIC int WINAPI FtpLogin(HCLIENT, LPCSTR, LPCSTR, LPCSTR);

!#endif /* WIN32 */

Section('SocketTools FTP')


        module('CSFTPL32.DLL')

            FtpSetLastError(signed), raw, pascal
            FtpGetLastError(), signed, raw, pascal
            FtpDisconnect(HCLIENT), signed, raw, pascal
            FtpGetSocket(HCLIENT), SOCKET, raw, pascal
            FtpCloseFile(HCLIENT), signed, raw, pascal
            FtpEndOfFile(HCLIENT), signed, raw, pascal
            FtpRead(HCLIENT, LPBYTE, signed), signed, raw, pascal
            FtpWrite(HCLIENT, LPBYTE, signed), signed, raw, pascal
            FtpGetResultCode(HCLIENT), signed, raw, pascal
            FtpAsyncNotify(HCLIENT, HWND, unsigned), signed, raw, pascal
            FtpReset(HCLIENT), signed, raw, pascal
            FtpCancel(HCLIENT), signed, raw, pascal
            FtpIsBlocking(HCLIENT), signed, raw, pascal
            FtpLogout(HCLIENT), signed, raw, pascal
            FtpSetFileType(HCLIENT, unsigned), signed, raw, pascal
            FtpSetFileStructure(HCLIENT, unsigned), signed, raw, pascal
            FtpSetFileMode(HCLIENT, unsigned), signed, raw, pascal
            FtpSetPassiveMode(HCLIENT, BOOL), signed, raw, pascal
            FtpAllocate(HCLIENT, DWORD, DWORD), signed, raw, pascal
            FtpChangeDirectoryUp(HCLIENT), signed, raw, pascal
            FtpGetBytesCopied(HCLIENT), ulong, raw, pascal
            FtpGetTransferTime(HCLIENT), ulong, raw, pascal
            FtpGetTimeout(HCLIENT), signed, raw, pascal
            FtpSetTimeout(HCLIENT, int), signed, raw, pascal
            FtpRestart(HCLIENT, DWORD), signed, raw, pascal
            FtpUninitialize, raw, pascal

            Omit('***', _WIDTH32_ )
                FtpInitialize(*LPCSTR, DWORD), BOOL, raw, pascal
                FtpConnect(*LPCSTR, UINT, UINT), HCLIENT, raw, pascal
                FtpGetErrorString(signed, *LPSTR, signed), signed, raw, pascal
                FtpOpenFile(HCLIENT, *LPCSTR, UINT), signed, raw, pascal
                FtpFileList(HCLIENT, *LPCSTR, BOOL), signed, raw, pascal
                FtpCommand(HCLIENT, *LPCSTR, *LPCSTR), signed, raw, pascal
                FtpGetResultString(HCLIENT, *LPSTR, signed), signed, raw, pascal
                FtpGetFileLength(HCLIENT, *LPCSTR, *LPDWORD), signed, raw, pascal
                FtpRenameFile(HCLIENT, *LPCSTR, *LPCSTR), signed, raw, pascal
                FtpRemoveFile(HCLIENT, *LPCSTR), signed, raw, pascal
                FtpChangeDirectory(HCLIENT, *LPCSTR), signed, raw, pascal
                FtpGetDirectory(HCLIENT, *LPSTR, signed), signed, raw, pascal
                FtpCreateDirectory(HCLIENT, *LPCSTR), signed, raw, pascal
                FtpRemoveDirectory(HCLIENT, *LPCSTR), signed, raw, pascal
                FtpMountStructure(HCLIENT, *LPCSTR), signed, raw, pascal
                FtpGetSystemInfo(HCLIENT, *LPSTR, signed), signed, raw, pascal
                FtpGetStatus(HCLIENT, *LPSTR, signed), signed, raw, pascal
                FtpGetFile(HCLIENT, *LPCSTR, *LPCSTR, BOOL), signed, raw, pascal
                FtpPutFile(HCLIENT, *LPCSTR, *LPCSTR, BOOL), signed, raw, pascal
                FtpUsername(HCLIENT, *LPCSTR), signed, raw, pascal
                FtpPassword(HCLIENT, *LPCSTR), signed, raw, pascal
                FtpAccount(HCLIENT, *LPCSTR), signed, raw, pascal
                FtpLogin(HCLIENT, *LPCSTR, *LPCSTR, *LPCSTR), signed, raw, pascal
            ***
            Compile('***', _WIDTH32_ )
                FtpInitialize(*LPCSTR, DWORD), BOOL, raw, pascal, Name('FtpInitializeA')
                FtpConnect(*LPCSTR, UINT, UINT), HCLIENT, raw, pascal, Name('FtpConnectA')
                FtpGetErrorString(signed, *LPSTR, signed), signed, raw, pascal, Name('FtpGetErrorStringA')
                FtpOpenFile(HCLIENT, *LPCSTR, UINT), signed, raw, pascal, Name('FtpOpenFileA')
                FtpFileList(HCLIENT, *LPCSTR, BOOL), signed, raw, pascal, Name('FtpFileListA')
                FtpCommand(HCLIENT, *LPCSTR, *LPCSTR), signed, raw, pascal, Name('FtpCommandA')
                FtpGetResultString(HCLIENT, *LPSTR, signed), signed, raw, pascal, Name('FtpGetResultStringA')
                FtpGetFileLength(HCLIENT, *LPCSTR, *LPDWORD), signed, raw, pascal, Name('FtpGetFileLengthA')
                FtpRenameFile(HCLIENT, *LPCSTR, *LPCSTR), signed, raw, pascal, Name('FtpGetFileLengthA')
                FtpRemoveFile(HCLIENT, *LPCSTR), signed, raw, pascal, Name('FtpRemoveFileA')
                FtpChangeDirectory(HCLIENT, *LPCSTR), signed, raw, pascal, Name('FtpChangeDirectoryA')
                FtpGetDirectory(HCLIENT, *LPSTR, signed), signed, raw, pascal, Name('FtpGetDirectoryA')
                FtpCreateDirectory(HCLIENT, *LPCSTR), signed, raw, pascal, Name('FtpCreateDirectoryA')
                FtpRemoveDirectory(HCLIENT, *LPCSTR), signed, raw, pascal, Name('FtpRemoveDirectoryA')
                FtpMountStructure(HCLIENT, *LPCSTR), signed, raw, pascal, Name('FtpMountStructureA')
                FtpGetSystemInfo(HCLIENT, *LPSTR, signed), signed, raw, pascal, Name('FtpGetSystemInfoA')
                FtpGetStatus(HCLIENT, *LPSTR, signed), signed, raw, pascal, Name('FtpGetStatusA')
                FtpGetFile(HCLIENT, *LPCSTR, *LPCSTR, BOOL), signed, raw, pascal, Name('FtpGetFileA')
                FtpPutFile(HCLIENT, *LPCSTR, *LPCSTR, BOOL), signed, raw, pascal, Name('FtpPutFileA')
                FtpUsername(HCLIENT, *LPCSTR), signed, raw, pascal, Name('FtpUsernameA')
                FtpPassword(HCLIENT, *LPCSTR), signed, raw, pascal, Name('FtpPasswordA')
                FtpAccount(HCLIENT, *LPCSTR), signed, raw, pascal, Name('FtpAccountA')
                FtpLogin(HCLIENT, *LPCSTR, *LPCSTR, *LPCSTR), signed, raw, pascal, Name('FtpLoginA')
            ***

        end ! module('CSFTPL32.LIB')

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Gopher client libraries CSGPRL16.DLL and CSGPRL32.DLL
! *
! ************************************************************************/

!PUBLIC int WINAPI GopherDisconnect(HCLIENT);
!PUBLIC int WINAPI GopherAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC VOID WINAPI GopherSetLastError(int);
!PUBLIC int WINAPI GopherGetLastError(VOID);
!PUBLIC SOCKET WINAPI GopherGetSocket(HCLIENT);
!PUBLIC int WINAPI GopherRead(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI GopherGetTimeout(HCLIENT);
!PUBLIC int WINAPI GopherSetTimeout(HCLIENT, int);
!PUBLIC BOOL WINAPI GopherIsBlocking(HCLIENT);
!PUBLIC BOOL WINAPI GopherCancel(HCLIENT);
!PUBLIC int WINAPI GopherGetItemCount(HCLIENT);
!PUBLIC UINT WINAPI GopherGetItemType(HCLIENT, int);
!PUBLIC UINT WINAPI GopherGetItemPort(HCLIENT, int);
!PUBLIC VOID WINAPI GopherUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI GopherInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI GopherInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define GopherInitialize GopherInitializeW
!#else
!#define GopherInitialize GopherInitializeA
!#endif

!PUBLIC HCLIENT WINAPI GopherAsyncConnectW(LPCWSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI GopherAsyncConnectA(LPCSTR, UINT, UINT, HWND, UINT);
!#ifdef UNICODE
!#define GopherAsyncConnect GopherAsyncConnectW
!#else
!#define GopherAsyncConnect GopherAsyncConnectA
!#endif

!PUBLIC HCLIENT WINAPI GopherConnectW(LPCWSTR, UINT, UINT);
!PUBLIC HCLIENT WINAPI GopherConnectA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define GopherConnect GopherConnectW
!#else
!#define GopherConnect GopherConnectA
!#endif

!PUBLIC int WINAPI GopherGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI GopherGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define GopherGetErrorString GopherGetErrorStringW
!#else
!#define GopherGetErrorString GopherGetErrorStringA
!#endif

!PUBLIC int WINAPI GopherSelectItemW(HCLIENT, UINT, LPCWSTR);
!PUBLIC int WINAPI GopherSelectItemA(HCLIENT, UINT, LPCSTR);
!#ifdef UNICODE
!#define GopherSelectItem GopherSelectItemW
!#else
!#define GopherSelectItem GopherSelectItemA
!#endif

!PUBLIC LPCWSTR WINAPI GopherGetItemDescriptionW(HCLIENT, int);
!PUBLIC LPCSTR WINAPI GopherGetItemDescriptionA(HCLIENT, int);
!#ifdef UNICODE
!#define GopherGetItemDescription GopherGetItemDescriptionW
!#else
!#define GopherGetItemDescription GopherGetItemDescriptionA
!#endif

!PUBLIC LPCWSTR WINAPI GopherGetItemSelectorW(HCLIENT, int);
!PUBLIC LPCSTR WINAPI GopherGetItemSelectorA(HCLIENT, int);
!#ifdef UNICODE
!#define GopherGetItemSelector GopherGetItemSelectorW
!#else
!#define GopherGetItemSelector GopherGetItemSelectorA
!#endif

!PUBLIC LPCWSTR WINAPI GopherGetItemHostNameW(HCLIENT, int);
!PUBLIC LPCSTR WINAPI GopherGetItemHostNameA(HCLIENT, int);
!#ifdef UNICODE
!#define GopherGetItemHostName GopherGetItemHostNameW
!#else
!#define GopherGetItemHostName GopherGetItemHostNameA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI GopherInitialize(LPCSTR, DWORD);
!PUBLIC HCLIENT WINAPI GopherAsyncConnect(LPCSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI GopherConnect(LPCSTR, UINT, UINT);
!PUBLIC int WINAPI GopherGetErrorString(int, LPSTR, int);
!PUBLIC int WINAPI GopherSelectItem(HCLIENT, UINT, LPCSTR);
!PUBLIC LPCSTR WINAPI GopherGetItemDescription(HCLIENT, int);
!PUBLIC LPCSTR WINAPI GopherGetItemSelector(HCLIENT, int);
!PUBLIC LPCSTR WINAPI GopherGetItemHostName(HCLIENT, int);

!#endif /* WIN32 */

Section('SocketTools Gopher Client Libraries')

        Module('csgprl32.dll')
            GopherDisconnect(HCLIENT), Signed, Pascal
            GopherAsyncNotify(HCLIENT, HWND, Unsigned), Signed, Pascal
            GopherSetLastError(Signed), Pascal
            GopherGetLastError(), Signed, Pascal
            GopherGetSocket(HCLIENT), Socket, Pascal
            GopherRead(HCLIENT, LPBYTE, Signed), Signed, Pascal
            GopherGetTimeout(HCLIENT), Signed, Pascal
            GopherSetTimeout(HCLIENT, Signed), Signed, Pascal
            GopherIsBlocking(HCLIENT), BOOL, Pascal
            GopherCancel(HCLIENT), BOOL, Pascal
            GopherGetItemCount(HCLIENT), Signed, Pascal
            GopherGetItemType(HCLIENT, Signed), Unsigned, Pascal
            GopherGetItemPort(HCLIENT, Signed), UnSigned, Pascal
            GopherUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                GopherInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('GopherInitializeA')
                GopherAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal, Name('GopherAsyncConnectA')
                GopherConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal, Name('GopherConnectA')
                GopherGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('GopherGetErrorStringA')
                GopherSelectItem(HCLIENT, Unsigned, *CString), Signed, Raw, Pascal, Name('GopherSelectItemA')
                GopherGetItemDescription(HCLIENT, Signed), LPCStr, Pascal, Name('GopherGetItemDescriptionA')
                GopherGetItemSelector(HCLIENT, Signed), LPCStr, Pascal, Name('GopherGetItemSelectorA')
                GopherGetItemHostName(HCLIENT, Signed), LPCStr, Pascal, Name('GopherGetItemHostNameA')
            ***
            Omit('***', _WIDTH32_ )
                GopherInitialize(*CString, DWORD), BOOL, Raw, Pascal
                GopherAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal
                GopherConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal
                GopherGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
                GopherSelectItem(HCLIENT, Unsigned, *CString), Signed, Raw, Pascal
                GopherGetItemDescription(HCLIENT, Signed), *Cstring, Pascal
                GopherGetItemSelector(HCLIENT, Signed), *CString, Pascal
                GopherGetItemHostName(HCLIENT, Signed), *CString, Pascal
            ***
        end   ! Module('SocketTools Gopher Client Libraries')

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * HyperText Transfer Protocol (HTTP) client libraries cshtp16.DLL
! * and cshtp32.dll
! *
! *************************************************************************/
Section ('SocketTools HTTP Client Libraries')


        Module ('cshtpl32.dll')
            HttpDisconnect(HCLIENT), Signed, Pascal
            HttpGetLastError(), Signed, Pascal
            HttpCancel(HCLIENT),Signed, Pascal
            HttpCloseFile(HCLIENT), signed, pascal
            HttpDisableEvents(HCLIENT), Signed, Pascal
            HttpEnableEvents(HCLIENT, HWND, unsigned), Signed, Pascal
            HttpFlush(HCLIENT),Signed, Pascal
            HttpFreezeEvents(HCLIENT, BOOL), Signed, Pascal
            HttpGetBytesCopied(HCLIENT),Signed, Pascal
            HttpGetResultCode(HCLIENT), Signed, Pascal
            HttpGetSocket(HCLIENT), Socket, Pascal
            HttpGetTimeout(HCLIENT), signed, pascal
            HttpGetTransferTime(HCLIENT), ulong, raw, pascal
            HttpIsBlocking(HCLIENT),BOOL, Pascal
            HttpIsConnected(HCLIENT), BOOL, Pascal
            HttpIsReadable(HCLIENT, LPDWORD), BOOL, Pascal
            HttpIsWritable(HCLIENT), BOOL, Pascal
            HttpRead(HCLIENT, LPBYTE, signed), signed, pascal
            HttpRegisterEvent(HCLIENT, unsigned,HTTPEVENTPROC,DWORD),signed, pascal
            HttpSetLastError(signed),raw,pascal
            HttpSetTimeout(HCLIENT, signed), signed, pascal
            HttpUninitialize(), raw, pascal
            HttpWrite(HCLIENT, LPBYTE, signed), signed, pascal
            Compile ('***', _WIDTH32_)
                HttpInitialize(*CString,DWORD),Bool,raw,pascal,name('HttpInitializeA')
                HttpAsyncConnect(*CString, unsigned, unsigned, DWORD, DWORD, HWND, unsigned), signed, pascal,name('HttpAsyncConnectA')
                HttpAuthenticate(HCLIENT, unsigned, *CString, *CString), signed, pascal, name('HttpAuthenticateA')
                HttpConnect(*CString, unsigned, unsigned, DWORD, DWORD), signed, pascal, name('HttpConnectA')
                HttpCreateFile(HCLIENT, *CString, DWORD, DWORD), signed, pascal, name('HttpCreateFileA')
                HttpDeleteFile(HCLIENT, *CString), signed, pascal, name('HttpDeleteFileA')
                HttpGetErrorString(HCLIENT, *CString, signed), signed, pascal, name('HttpGetErrorStringA')
                HttpGetFile(HCLIENT, *CString, *CString), signed, pascal, name('HttpGetFileA')
                HttpGetFileLength(HCLIENT, *CString, DWORD), signed, pascal, name('HttpGetFileLengthA')
                HttpGetRequestHeader(HCLIENT, *CString, LPTSTR, signed), signed, pascal, name('HttpGetRequestHeaderA')
                HttpGetResponseHeader(HCLIENT, *CString, LPTSTR, signed), signed, pascal, name('HttpGetResponseHeaderA')
                HttpGetResultString(HCLIENT, LPTSTR, signed), signed, pascal, name('HttpGetResultStringA')
                HttpOpenFile(HCLIENT, *CString, DWORD), signed, pascal, name('HttpOpenFileA')
                HttpPutFile(HCLIENT, *CString, *CString), signed, pascal, name('HttpPutFileA')
                HttpSendRequest(HCLIENT, unsigned, LPCTSTR, LPCTSTR), signed, pascal, name('HttpSendRequestA')
                HttpSetRequestHeader(HCLIENT, *CString, LPTSTR), signed, pascal, name('HttpSetRequestHeaderA')
                HttpSubmitQuery(HCLIENT, *CString, *Cstring, DWORD), signed, pascal, name('HttpSubmitQueryA')
            ***
            Omit  ('***', _WIDTH32_)
                HttpInitialize(*CString,DWORD),Bool,raw,pascal
                HttpAsyncConnect(*CString, unsigned, unsigned, DWORD, DWORD, HWND, unsigned), signed, pascal
                HttpAuthenticate(HCLIENT, unsigned, *CString, *CString), signed, pascal
                HttpConnect(*CString, unsigned, unsigned, DWORD, DWORD), signed, pascal
                HttpCreateFile(HCLIENT, *CString, DWORD, DWORD), signed, pascal
                HttpDeleteFile(HCLIENT, *CString), signed, pascal
                HttpGetErrorString(HCLIENT, *CString, signed), signed, pascal
                HttpGetFile(HCLIENT, *CString, *CString), signed, pascal
                HttpGetFileLength(HCLIENT, *CString, DWORD), signed, pascal
                HttpGetRequestHeader(HCLIENT, *CString, LPTSTR, signed), signed, pascal
                HttpGetResponseHeader(HCLIENT, *Cstring, LPTSTR, signed), signed, pascal
                HttpGetResultString(HCLIENT, LPTSTR, signed), signed, pascal
                HttpOpenFile(HCLIENT, *CString, DWORD), signed, pascal
                HttpPutFile(HCLIENT, *CString, *CString), signed, pascal
                HttpSendRequest(HCLIENT, unsigned, *CString, *CString), signed, pascal
                HttpSetRequestHeader(HCLIENT, *CString, LPTSTR), signed, pascal
                HttpSubmitQuery(HCLIENT, *CString, *Cstring, DWORD), signed, pascal
            ***
        end     ! Module('SocketTools HTTP Client Library')


!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Internet Control Message Protocol (ICMP) client libraries
! * CSICMP16.DLL and CSICMP32.DLL
! *
! ************************************************************************/

!PUBLIC HCLIENT WINAPI IcmpAsyncOpen(HWND, UINT);
!PUBLIC HCLIENT WINAPI IcmpAsyncOpenEx(HWND, UINT, BOOL);
!PUBLIC HCLIENT WINAPI IcmpOpen(VOID);
!PUBLIC HCLIENT WINAPI IcmpOpenEx(BOOL);
!PUBLIC BOOL WINAPI IcmpClose(HCLIENT);
!PUBLIC BOOL WINAPI IcmpReset(HCLIENT);
!PUBLIC SOCKET WINAPI IcmpGetSocket(HCLIENT);
!PUBLIC BOOL WINAPI IcmpSetHostAddress(HCLIENT, DWORD);
!PUBLIC BOOL WINAPI IcmpSendEcho(HCLIENT);
!PUBLIC BOOL WINAPI IcmpRecvEcho(HCLIENT);
!PUBLIC UINT WINAPI IcmpGetSequenceId(HCLIENT);
!PUBLIC UINT WINAPI IcmpSetSequenceId(HCLIENT, UINT);
!PUBLIC UINT WINAPI IcmpGetRecvCount(HCLIENT);
!PUBLIC UINT WINAPI IcmpGetSendCount(HCLIENT);
!PUBLIC BOOL WINAPI IcmpGetTripTime(HCLIENT, LPICMPTIME);
!PUBLIC DWORD WINAPI IcmpGetTimeout(HCLIENT);
!PUBLIC UINT WINAPI IcmpGetTimeToLive(HCLIENT);
!PUBLIC BOOL WINAPI IcmpSetTimeToLive(HCLIENT, UINT);
!PUBLIC UINT WINAPI IcmpGetPacketSize(HCLIENT);
!PUBLIC UINT WINAPI IcmpSetPacketSize(HCLIENT, UINT);
!PUBLIC BOOL WINAPI IcmpAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC DWORD WINAPI IcmpSetTimeout(HCLIENT, DWORD);
!PUBLIC BOOL WINAPI IcmpIsBlocking(HCLIENT);
!PUBLIC BOOL WINAPI IcmpCancel(HCLIENT);
!PUBLIC VOID WINAPI IcmpSetLastError(int);
!PUBLIC int WINAPI IcmpGetLastError(VOID);
!PUBLIC VOID WINAPI IcmpUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI IcmpInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI IcmpInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define IcmpInitialize IcmpInitializeW
!#else
!#define IcmpInitialize IcmpInitializeA
!#endif

!PUBLIC BOOL WINAPI IcmpSetHostNameW(HCLIENT, LPCWSTR);
!PUBLIC BOOL WINAPI IcmpSetHostNameA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define IcmpSetHostName IcmpSetHostNameW
!#else
!#define IcmpSetHostName IcmpSetHostNameA
!#endif

!PUBLIC int WINAPI IcmpGetHostAddressW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI IcmpGetHostAddressA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define IcmpGetHostAddress IcmpGetHostAddressW
!#else
!#define IcmpGetHostAddress IcmpGetHostAddressA
!#endif

!PUBLIC int WINAPI IcmpGetHostNameW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI IcmpGetHostNameA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define IcmpGetHostName IcmpGetHostNameW
!#else
!#define IcmpGetHostName IcmpGetHostNameA
!#endif

!PUBLIC int WINAPI IcmpGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI IcmpGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define IcmpGetErrorString IcmpGetErrorStringW
!#else
!#define IcmpGetErrorString IcmpGetErrorStringA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI IcmpInitialize(LPCSTR, DWORD);
!PUBLIC BOOL WINAPI IcmpSetHostName(HCLIENT, LPCSTR);
!PUBLIC int WINAPI IcmpGetHostAddress(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI IcmpGetHostName(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI IcmpGetErrorString(int, LPSTR, int);

!#endif /* WIN32 */

Section('SocketTools ICMP')

        Module('csicmp32.dll')
            IcmpAsyncOpen(HWND, Unsigned), HCLIENT, Pascal
            IcmpAsyncOpenEx(HWND, Unsigned, BOOL), HCLIENT, Pascal
            IcmpOpen(), HCLIENT, Pascal
            IcmpOpenEx(), HCLIENT, Pascal
            IcmpClose(HCLIENT), BOOL, Pascal
            IcmpReset(HCLIENT), BOOL, Pascal
            IcmpGetSocket(HCLIENT), Socket, Pascal
            IcmpSetHostAddress(HCLIENT, DWORD), BOOL, Pascal
            IcmpSendEcho(HCLIENT), BOOL, Pascal
            IcmpRecvEcho(HCLIENT), BOOL, Pascal
            IcmpGetSequenceId(HCLIENT), UnSigned, Pascal
            IcmpSetSequenceId(HCLIENT, Unsigned), Unsigned, Pascal
            IcmpGetRecvCount(HCLIENT), Unsigned, Pascal
            IcmpGetSendCount(HCLIENT), Unsigned, Pascal
            IcmpGetTripTime(HCLIENT, LPICMPTIME), BOOL, Pascal, Raw
            IcmpGetTimeout(HCLIENT), ulong, Pascal
            IcmpGetTimeToLive(HCLIENT), Unsigned, Pascal
            IcmpSetTimeToLive(HCLIENT, Unsigned), BOOL, Pascal
            IcmpGetPacketSize(HCLIENT), Unsigned, Pascal
            IcmpSetPacketSize(HCLIENT, Unsigned), Unsigned, Pascal
            IcmpAsyncNotify(HCLIENT, HWND, Unsigned), BOOL, Pascal
            IcmpSetTimeout(HCLIENT, DWORD), ulong, Pascal
            IcmpIsBlocking(HCLIENT), BOOL, Pascal
            IcmpCancel(HCLIENT), BOOL, Pascal
            IcmpSetLastError(Signed), Pascal
            IcmpGetLastError(), Signed, Pascal
            IcmpUninitialize()
            Compile('***', _WIDTH32_ )
                IcmpInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('IcmpInitializeA')
                IcmpSetHostName(HCLIENT, *CString), BOOL, Raw, Pascal, Name('IcmpSetHostNameA')
                IcmpGetHostAddress(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('IcmpGetHostAddressA')
                IcmpGetHostName(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('IcmpGetHostNameA')
                IcmpGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('IcmpGetErrorStringA')
            ***
            Omit('***', _WIDTH32_ )
                IcmpInitialize(*CString, DWORD), BOOL, Raw, Pascal
                IcmpSetHostName(HCLIENT, *CString), BOOL, Raw, Pascal
                IcmpGetHostAddress(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                IcmpGetHostName(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                IcmpGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
            ***
        end   ! Module('SocketTools Internet Control Message Protocol (ICMP)')
!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * image viewer libraries CSIMGL16.DLL and CSIMGL32.DLL
! *
! ************************************************************************/

!PUBLIC VOID WINAPI UnloadImageTable(VOID);
!PUBLIC int WINAPI GetImageCount(VOID);
!PUBLIC BOOL WINAPI ImageCached(HANDLE);
!PUBLIC int WINAPI ResetImageCache(VOID);
!PUBLIC int WINAPI GetImageCacheSize(VOID);
!PUBLIC int WINAPI SetImageCacheSize(int);
!PUBLIC BOOL WINAPI UnregisterImageType(int);
!PUBLIC HANDLE WINAPI ReloadImage(HANDLE);
!PUBLIC BOOL WINAPI UnloadImage(HANDLE);
!PUBLIC BOOL WINAPI DeleteImage(HANDLE);
!PUBLIC BOOL WINAPI DrawImage(HDC, int, int, HANDLE);
!PUBLIC BOOL WINAPI StretchImage(HDC, int, int, int, int, HANDLE);
!PUBLIC DWORD WINAPI GetImageExtent(HANDLE, LPSIZE);
!PUBLIC int WINAPI GetImageUsage(HANDLE);
!PUBLIC int WINAPI GetImageType(HANDLE);
!PUBLIC int WINAPI GetImageColors(HANDLE);
!PUBLIC BOOL WINAPI GetImageTransColor(HANDLE, COLORREF FAR *);
!PUBLIC BOOL WINAPI SetImageTransColor(HANDLE, COLORREF);
!PUBLIC UINT WINAPI RealizeImagePalette(HDC, HANDLE, BOOL);
!PUBLIC HPALETTE WINAPI GetImagePalette(HANDLE);
!PUBLIC HPALETTE WINAPI CreateImagePalette(HANDLE FAR *, int);
!PUBLIC HBITMAP WINAPI GetImageBitmap(HANDLE);

!#ifdef WIN32

!PUBLIC int WINAPI RegisterImageTypeW(LPCWSTR, LPCWSTR, LPCWSTR);
!PUBLIC int WINAPI RegisterImageTypeA(LPCSTR, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define RegisterImageType RegisterImageTypeW
!#else
!#define RegisterImageType RegisterImageTypeA
!#endif

!PUBLIC HANDLE WINAPI LoadImageFileW(LPCWSTR, int);
!PUBLIC HANDLE WINAPI LoadImageFileA(LPCSTR, int);
!#ifdef UNICODE
!#define LoadImageFile LoadImageFileW
!#else
!#define LoadImageFile LoadImageFileA
!#endif

!PUBLIC int WINAPI GetImageFileW(HANDLE, LPWSTR, int);
!PUBLIC int WINAPI GetImageFileA(HANDLE, LPSTR, int);
!#ifdef UNICODE
!#define GetImageFile GetImageFileW
!#else
!#define GetImageFile GetImageFileA
!#endif

!PUBLIC int WINAPI GetImageFileTypeW(LPCWSTR);
!PUBLIC int WINAPI GetImageFileTypeA(LPCSTR);
!#ifdef UNICODE
!#define GetImageFileType GetImageFileTypeW
!#else
!#define GetImageFileType GetImageFileTypeA
!#endif

!PUBLIC LPCWSTR WINAPI GetImageFileTypeExtensionW(int);
!PUBLIC LPCSTR WINAPI GetImageFileTypeExtensionA(int);
!#ifdef UNICODE
!#define GetImageFileTypeExtension GetImageFileTypeExtensionW
!#else
!#define GetImageFileTypeExtension GetImageFileTypeExtensionA
!#endif

!#else /* !WIN32 */

!PUBLIC int WINAPI RegisterImageType(LPCSTR, LPCSTR, LPCSTR);
!PUBLIC HANDLE WINAPI LoadImageFile(LPCSTR, int);
!PUBLIC int WINAPI GetImageFile(HANDLE, LPSTR, int);
!PUBLIC int WINAPI GetImageFileType(LPCSTR);
!PUBLIC LPCSTR WINAPI GetImageFileTypeExtension(int);

!#endif /* WIN32 */

Section('SocketTools Image Viewer')

        Module('csimgl32.dll')
            LoadImageLibraries(), Signed, Pascal
            UnloadImageLibraries(), BOOL, Pascal
            UnloadImageTable(), Pascal
            GetImageCount(), Signed, Pascal
            ImageCached(HANDLE), BOOL, Pascal
            ResetImageCache(), Signed, Pascal
            GetImageCacheSize(), Signed, Pascal
            SetImageCacheSize(Signed), Signed, Pascal
            UnregisterImageType(Signed), BOOL, Pascal
            ReloadImage(HANDLE), long, Pascal
            UnloadImage(HANDLE), BOOL, Pascal
            DeleteImage(HANDLE), BOOL, Pascal
            DrawImage(HDC, Signed, Signed, HANDLE), BOOL, Pascal
            StretchImage(HDC, Signed, Signed, Signed, Signed, HANDLE), BOOL, Pascal
            GetImageExtent(HANDLE, LPSIZE), ulong, Pascal
            GetImageUsage(HANDLE), Signed, Pascal
            GetImageType(HANDLE), Signed, Pascal
            GetImageColors(HANDLE), Signed, Pascal
            GetImageTransColor(HANDLE, *COLORREF), BOOL, Raw, Pascal
            SetImageTransColor(HANDLE, COLORREF), BOOL, Raw, Pascal
            RealizeImagePalette(HDC, HANDLE, BOOL), Unsigned, Pascal
            GetImagePalette(HANDLE), long, Pascal
            CreateImagePalette(*HANDLE, Signed), long, Pascal
            GetImageBitmap(HANDLE), ulong, Pascal
            Compile('***', _WIDTH32_ )
                RegisterImageType(*CString, *CString, *CString), Signed, Raw, Pascal, Name('RegisterImageTypeA')
                LoadImageFile(*CString, Signed), long, Raw, Pascal, Name('LoadImageFileA')
                GetImageFile(HANDLE, *CString, Signed), Signed, Raw, Pascal, Name('GetImageFileA')
                GetImageFileType(*CString), Signed, Raw, Pascal, Name('GetImageFileTypeA')
                GetImageFileTypeExtension(Signed), *CString, Pascal, Name('GetImageFileTypeExtensionA')
            ***
            Omit('***', _WIDTH32_ )
                RegisterImageType(*CString, *CString, *CString), Signed, Raw, Pascal
                LoadImageFile(*CString, Signed), long, Raw, Pascal
                GetImageFile(HANDLE, *CString, Signed), Signed, Raw, Pascal
                GetImageFileType(*CString), Signed, Raw, Pascal
                GetImageFileTypeExtension(Signed),*Cstring, Pascal
            ***
        end   ! Module('SocketTools Image Viewer Library')


!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Multipurpose Internet Mail Extensions (MIME) libraries
! * CSMSGL16.DLL and CSMSGL32.DLL
! *
! ************************************************************************/

!PUBLIC VOID WINAPI MimeSetLastError(int);
!PUBLIC int WINAPI MimeGetLastError();
!PUBLIC HMESSAGE WINAPI MimeCreateMessage(VOID);
!PUBLIC int WINAPI MimeCreateMessagePart(HMESSAGE);
!PUBLIC BOOL WINAPI MimeResetMessage(HMESSAGE);
!PUBLIC BOOL WINAPI MimeDeleteMessage(HMESSAGE);
!PUBLIC BOOL WINAPI MimeDeleteMessagePart(HMESSAGE, int);
!PUBLIC BOOL WINAPI MimeClearMessageText(HMESSAGE);
!PUBLIC int WINAPI MimeGetMessagePartCount(HMESSAGE);
!PUBLIC int WINAPI MimeGetMessagePart(HMESSAGE);
!PUBLIC int WINAPI MimeSetMessagePart(HMESSAGE, int);
!PUBLIC LPCSTR WINAPI MimeGetMessageVersion(HMESSAGE);
!PUBLIC LPCSTR WINAPI MimeGetMessageDate(HMESSAGE, BOOL);
!PUBLIC LONG WINAPI MimeGetContentLength(HMESSAGE);
!PUBLIC LPCSTR WINAPI MimeGetMessageBoundary(HMESSAGE);
!PUBLIC VOID WINAPI MimeUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI MimeInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI MimeInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define MimeInitialize MimeInitializeW
!#else
!#define MimeInitialize MimeInitializeA
!#endif

!PUBLIC int WINAPI MimeGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI MimeGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define MimeGetErrorString MimeGetErrorStringW
!#else
!#define MimeGetErrorString MimeGetErrorStringA
!#endif

!PUBLIC LPCWSTR WINAPI MimeGetMessageHeaderW(HMESSAGE, LPCWSTR);
!PUBLIC LPCSTR WINAPI MimeGetMessageHeaderA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeGetMessageHeader MimeGetMessageHeaderW
!#else
!#define MimeGetMessageHeader MimeGetMessageHeaderA
!#endif

!PUBLIC BOOL WINAPI MimeSetMessageHeaderW(HMESSAGE, LPCWSTR, LPCWSTR);
!PUBLIC BOOL WINAPI MimeSetMessageHeaderA(HMESSAGE, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define MimeSetMessageHeader MimeSetMessageHeaderW
!#else
!#define MimeSetMessageHeader MimeSetMessageHeaderA
!#endif

!PUBLIC BOOL WINAPI MimeDeleteMessageHeaderW(HMESSAGE, LPCWSTR);
!PUBLIC BOOL WINAPI MimeDeleteMessageHeaderA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeDeleteMessageHeader MimeDeleteMessageHeaderW
!#else
!#define MimeDeleteMessageHeader MimeDeleteMessageHeaderA
!#endif

!PUBLIC LONG WINAPI MimeGetMessageTextW(HMESSAGE, LONG, LPWSTR, LONG);
!PUBLIC LONG WINAPI MimeGetMessageTextA(HMESSAGE, LONG, LPSTR, LONG);
!#ifdef UNICODE
!#define MimeGetMessageText MimeGetMessageTextW
!#else
!#define MimeGetMessageText MimeGetMessageTextA
!#endif

!PUBLIC LONG WINAPI MimeSetMessageTextW(HMESSAGE, LONG, LPCWSTR);
!PUBLIC LONG WINAPI MimeSetMessageTextA(HMESSAGE, LONG, LPCSTR);
!#ifdef UNICODE
!#define MimeSetMessageText MimeSetMessageTextW
!#else
!#define MimeSetMessageText MimeSetMessageTextA
!#endif

!PUBLIC LONG WINAPI MimeAppendMessageTextW(HMESSAGE, LPCWSTR);
!PUBLIC LONG WINAPI MimeAppendMessageTextA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeAppendMessageText MimeAppendMessageTextW
!#else
!#define MimeAppendMessageText MimeAppendMessageTextA
!#endif

!PUBLIC BOOL WINAPI MimeSetMessageVersionW(HMESSAGE, LPCWSTR);
!PUBLIC BOOL WINAPI MimeSetMessageVersionA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeSetMessageVersion MimeSetMessageVersionW
!#else
!#define MimeSetMessageVersion MimeSetMessageVersionA
!#endif

!PUBLIC BOOL WINAPI MimeSetMessageDateW(HMESSAGE, LPCWSTR, BOOL);
!PUBLIC BOOL WINAPI MimeSetMessageDateA(HMESSAGE, LPCSTR, BOOL);
!#ifdef UNICODE
!#define MimeSetMessageDate MimeSetMessageDateW
!#else
!#define MimeSetMessageDate MimeSetMessageDateA
!#endif

!PUBLIC BOOL WINAPI MimeParseHeaderW(HMESSAGE, LPCWSTR);
!PUBLIC BOOL WINAPI MimeParseHeaderA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeParseHeader MimeParseHeaderW
!#else
!#define MimeParseHeader MimeParseHeaderA
!#endif

!PUBLIC BOOL WINAPI MimeParseBufferW(HMESSAGE, LPCWSTR, int);
!PUBLIC BOOL WINAPI MimeParseBufferA(HMESSAGE, LPCSTR, int);
!#ifdef UNICODE
!#define MimeParseBuffer MimeParseBufferW
!#else
!#define MimeParseBuffer MimeParseBufferA
!#endif

!PUBLIC BOOL WINAPI MimeImportMessageW(HMESSAGE, LPCWSTR);
!PUBLIC BOOL WINAPI MimeImportMessageA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeImportMessage MimeImportMessageW
!#else
!#define MimeImportMessage MimeImportMessageA
!#endif

!PUBLIC BOOL WINAPI MimeExportMessageW(HMESSAGE, LPCWSTR);
!PUBLIC BOOL WINAPI MimeExportMessageA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeExportMessage MimeExportMessageW
!#else
!#define MimeExportMessage MimeExportMessageA
!#endif

!PUBLIC BOOL WINAPI MimeGetAttachedFileNameW(HMESSAGE, LPWSTR, int);
!PUBLIC BOOL WINAPI MimeGetAttachedFileNameA(HMESSAGE, LPSTR, int);
!#ifdef UNICODE
!#define MimeGetAttachedFileName MimeGetAttachedFileNameW
!#else
!#define MimeGetAttachedFileName MimeGetAttachedFileNameA
!#endif

!PUBLIC BOOL WINAPI MimeAttachFileW(HMESSAGE, LPCWSTR);
!PUBLIC BOOL WINAPI MimeAttachFileA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeAttachFile MimeAttachFileW
!#else
!#define MimeAttachFile MimeAttachFileA
!#endif

!PUBLIC BOOL WINAPI MimeExtractFileW(HMESSAGE, LPCWSTR);
!PUBLIC BOOL WINAPI MimeExtractFileA(HMESSAGE, LPCSTR);
!#ifdef UNICODE
!#define MimeExtractFile MimeExtractFileW
!#else
!#define MimeExtractFile MimeExtractFileA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI MimeInitialize(LPCSTR, DWORD);
!PUBLIC int WINAPI MimeGetErrorString(int, LPSTR, int);
!PUBLIC LPCSTR WINAPI MimeGetMessageHeader(HMESSAGE, LPCSTR);
!PUBLIC BOOL WINAPI MimeSetMessageHeader(HMESSAGE, LPCSTR, LPCSTR);
!PUBLIC BOOL WINAPI MimeDeleteMessageHeader(HMESSAGE, LPCSTR);
!PUBLIC LONG WINAPI MimeGetMessageText(HMESSAGE, LONG, LPSTR, LONG);
!PUBLIC LONG WINAPI MimeSetMessageText(HMESSAGE, LONG, LPCSTR);
!PUBLIC LONG WINAPI MimeAppendMessageText(HMESSAGE, LPCSTR);
!PUBLIC BOOL WINAPI MimeSetMessageVersion(HMESSAGE, LPCSTR);
!PUBLIC BOOL WINAPI MimeSetMessageDate(HMESSAGE, LPCSTR, BOOL);
!PUBLIC BOOL WINAPI MimeParseHeader(HMESSAGE, LPCSTR);
!PUBLIC BOOL WINAPI MimeParseBuffer(HMESSAGE, LPCSTR, int);
!PUBLIC BOOL WINAPI MimeImportMessage(HMESSAGE, LPCSTR);
!PUBLIC BOOL WINAPI MimeExportMessage(HMESSAGE, LPCSTR);
!PUBLIC BOOL WINAPI MimeGetAttachedFileName(HMESSAGE, LPSTR, int);
!PUBLIC BOOL WINAPI MimeAttachFile(HMESSAGE, LPCSTR);
!PUBLIC BOOL WINAPI MimeExtractFile(HMESSAGE, LPCSTR);

!#endif /* WIN32 */

Section('SocketTools MIME')
        Module('csmsgl32.dll')
            MimeSetLastError(Signed), Pascal
            MimeGetLastError(), Signed, Pascal
            MimeCreateMessage(), HMessage, Pascal
            MimeCreateMessagePart(HMESSAGE), Signed, Pascal
            MimeResetMessage(HMESSAGE), BOOL, Pascal
            MimeDeleteMessage(HMESSAGE), BOOL, Pascal
            MimeDeleteMessagePart(HMESSAGE, Signed), BOOL, Pascal
            MimeClearMessageText(HMESSAGE), BOOL, Pascal
            MimeGetMessagePartCount(HMESSAGE), Signed, Pascal
            MimeGetMessagePart(HMESSAGE), Signed, Pascal
            MimeSetMessagePart(HMESSAGE, Signed), Signed, Pascal
            MimeGetMessageVersion(HMESSAGE), *CString, Pascal
            MimeGetMessageDate(HMESSAGE, BOOL), *CString, Pascal
            MimeGetContentLength(HMESSAGE), Long, Pascal
            MimeGetMessageBoundary(HMESSAGE), *CString, Pascal
            MimeUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                MimeInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('MimeInitializeA')
                MimeGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('MimeGetErrorStringA')
                MimeGetMessageHeader(HMESSAGE, *CString), *CString, Raw, Pascal, Name('MimeGetMessageHeaderA')
                MimeSetMessageHeader(HMESSAGE, *CString, *CString), BOOL, Raw, Pascal, Name('MimeSetMessageHeaderA')
                MimeDeleteMessageHeader(HMESSAGE, *CString), BOOL, Raw, Pascal, Name('MimeDeleteMessageHeaderA')
                MimeGetMessageText(HMESSAGE, LONG, *CString, LONG), Long, Raw, Pascal, Name('MimeGetMessageTextA')
                MimeSetMessageText(HMESSAGE, LONG, *CString), Long, Raw, Pascal, Name('MimeSetMessageTextA')
                MimeAppendMessageText(HMESSAGE, *CString), Long, Raw, Pascal, Name('MimeAppendMessageTextA')
                MimeSetMessageVersion(HMESSAGE, *CString), BOOL, Raw, Pascal, Name('MimeSetMessageVersionA')
                MimeSetMessageDate(HMESSAGE, *CString, BOOL), BOOL, Raw, Pascal, Name('MimeSetMessageDateA')
                MimeParseHeader(HMESSAGE, *CString), BOOL, Raw, Pascal, Name('MimeParseHeaderA')
                MimeParseBuffer(HMESSAGE, *CString, Signed), BOOL, Raw, Pascal, Name('MimeParseBufferA')
                MimeImportMessage(HMESSAGE, *CString), BOOL, Raw, Pascal, Name('MimeImportMessageA')
                MimeExportMessage(HMESSAGE, *CString), BOOL, Raw, Pascal, Name('MimeExportMessageA')
                MimeGetAttachedFileName(HMESSAGE, *CString, Signed), BOOL, Raw, Pascal, Name('MimeGetAttachedFileNameA')
                MimeAttachFile(HMESSAGE, *CString), BOOL, Raw, Pascal, Name('MimeAttachFileA')
                MimeExtractFile(HMESSAGE, *CString), BOOL, Raw, Pascal, Name('MimeExtractFileA')
            ***
            Omit('***', _WIDTH32_ )
                MimeInitialize(*CString, DWORD), BOOL, Raw, Pascal
                MimeGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
                MimeGetMessageHeader(HMESSAGE, *CString), *CString, Raw, Pascal
                MimeSetMessageHeader(HMESSAGE, *CString, *CString), BOOL, Raw, Pascal
                MimeDeleteMessageHeader(HMESSAGE, *CString), BOOL, Raw, Pascal
                MimeGetMessageText(HMESSAGE, LONG, *CString, LONG), Long, Raw, Pascal
                MimeSetMessageText(HMESSAGE, LONG, *CString), Long, Raw, Pascal
                MimeAppendMessageText(HMESSAGE, *CString), Long, Raw, Pascal
                MimeSetMessageVersion(HMESSAGE, *CString), BOOL, Raw, Pascal
                MimeSetMessageDate(HMESSAGE, *CString, BOOL), BOOL, Raw, Pascal
                MimeParseHeader(HMESSAGE, *CString), BOOL, Raw, Pascal
                MimeParseBuffer(HMESSAGE, *CString, Signed), BOOL, Raw, Pascal
                MimeImportMessage(HMESSAGE, *CString), BOOL, Raw, Pascal
                MimeExportMessage(HMESSAGE, *CString), BOOL, Raw, Pascal
                MimeGetAttachedFileName(HMESSAGE, *CString, Signed), BOOL, Raw, Pascal
                MimeAttachFile(HMESSAGE, *CString), BOOL, Raw, Pascal
                MimeExtractFile(HMESSAGE, *CString), BOOL, Raw, Pascal
            ***
        end   ! Module('SocketTools MIME Library')

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Network News Tranfer Protocol (NNTP) client libraries
! * CSNWSL16.DLL and CSNWSL32.DLL
! *
! ************************************************************************/

!PUBLIC int WINAPI NntpDisconnect(HCLIENT);
!PUBLIC int WINAPI NntpAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC VOID WINAPI NntpSetLastError(int);
!PUBLIC int WINAPI NntpGetLastError();
!PUBLIC SOCKET WINAPI NntpGetSocket(HCLIENT);
!PUBLIC int WINAPI NntpReadResult(HCLIENT);
!PUBLIC int WINAPI NntpGetResultCode(HCLIENT);
!PUBLIC int WINAPI NntpRead(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI NntpWrite(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI NntpReset(HCLIENT);
!PUBLIC int WINAPI NntpGetTimeout(HCLIENT);
!PUBLIC int WINAPI NntpSetTimeout(HCLIENT, int);
!PUBLIC int WINAPI NntpListGroups(HCLIENT);
!PUBLIC LONG WINAPI NntpGetArticleRange(HCLIENT, LPLONG, LPLONG);
!PUBLIC LONG WINAPI NntpGetCurrentArticle(HCLIENT);
!PUBLIC int WINAPI NntpListArticles(HCLIENT, LONG, LONG);
!PUBLIC int WINAPI NntpGetArticleHeader(HCLIENT, LONG);
!PUBLIC int WINAPI NntpGetArticleByNumber(HCLIENT, LONG);
!PUBLIC int WINAPI NntpGetNextArticle(HCLIENT);
!PUBLIC int WINAPI NntpGetPreviousArticle(HCLIENT);
!PUBLIC int WINAPI NntpCreateArticle(HCLIENT);
!PUBLIC int WINAPI NntpCloseArticle(HCLIENT);
!PUBLIC BOOL WINAPI NntpIsBlocking(HCLIENT);
!PUBLIC int WINAPI NntpCancel(HCLIENT);
!PUBLIC int WINAPI NntpSetMultiLine(HCLIENT, BOOL);
!PUBLIC int WINAPI NntpGetMultiLine(HCLIENT, BOOL FAR *);
!PUBLIC VOID WINAPI NntpUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI NntpInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI NntpInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define NntpInitialize NntpInitializeW
!#else
!#define NntpInitialize NntpInitializeA
!#endif

!PUBLIC HCLIENT WINAPI NntpAsyncConnectW(LPCWSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI NntpAsyncConnectA(LPCSTR, UINT, UINT, HWND, UINT);
!#ifdef UNICODE
!#define NntpAsyncConnect NntpAsyncConnectW
!#else
!#define NntpAsyncConnect NntpAsyncConnectA
!#endif

!PUBLIC HCLIENT WINAPI NntpConnectW(LPCWSTR, UINT, UINT);
!PUBLIC HCLIENT WINAPI NntpConnectA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define NntpConnect NntpConnectW
!#else
!#define NntpConnect NntpConnectA
!#endif

!PUBLIC int WINAPI NntpGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI NntpGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define NntpGetErrorString NntpGetErrorStringW
!#else
!#define NntpGetErrorString NntpGetErrorStringA
!#endif

!PUBLIC int WINAPI NntpCommandW(HCLIENT, LPCWSTR, LPCWSTR);
!PUBLIC int WINAPI NntpCommandA(HCLIENT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define NntpCommand NntpCommandW
!#else
!#define NntpCommand NntpCommandA
!#endif

!PUBLIC int WINAPI NntpGetResultStringW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI NntpGetResultStringA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define NntpGetResultString NntpGetResultStringW
!#else
!#define NntpGetResultString NntpGetResultStringA
!#endif

!PUBLIC int WINAPI NntpListNewGroupsW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI NntpListNewGroupsA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define NntpListNewGroups NntpListNewGroupsW
!#else
!#define NntpListNewGroups NntpListNewGroupsA
!#endif

!PUBLIC int WINAPI NntpSelectGroupW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI NntpSelectGroupA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define NntpSelectGroup NntpSelectGroupW
!#else
!#define NntpSelectGroup NntpSelectGroupA
!#endif

!PUBLIC int WINAPI NntpGetGroupNameW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI NntpGetGroupNameA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define NntpGetGroupName NntpGetGroupNameW
!#else
!#define NntpGetGroupName NntpGetGroupNameA
!#endif

!PUBLIC int WINAPI NntpGetGroupTitleW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI NntpGetGroupTitleA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define NntpGetGroupTitle NntpGetGroupTitleW
!#else
!#define NntpGetGroupTitle NntpGetGroupTitleA
!#endif

!PUBLIC int WINAPI NntpGetArticleMessageIdW(HCLIENT, LONG, LPWSTR, int);
!PUBLIC int WINAPI NntpGetArticleMessageIdA(HCLIENT, LONG, LPSTR, int);
!#ifdef UNICODE
!#define NntpGetArticleMessageId NntpGetArticleMessageIdW
!#else
!#define NntpGetArticleMessageId NntpGetArticleMessageIdA
!#endif

!PUBLIC LONG WINAPI NntpGetMessageIdArticleW(HCLIENT, LPCWSTR);
!PUBLIC LONG WINAPI NntpGetMessageIdArticleA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define NntpGetMessageIdArticle NntpGetMessageIdArticleW
!#else
!#define NntpGetMessageIdArticle NntpGetMessageIdArticleA
!#endif

!PUBLIC int WINAPI NntpGetArticleByMessageIdW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI NntpGetArticleByMessageIdA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define NntpGetArticleByMessageId NntpGetArticleByMessageIdW
!#else
!#define NntpGetArticleByMessageId NntpGetArticleByMessageIdA
!#endif

!PUBLIC int WINAPI NntpAuthenticateW(HCLIENT, LPCWSTR, LPCWSTR);
!PUBLIC int WINAPI NntpAuthenticateA(HCLIENT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define NntpAuthenticate NntpAuthenticateW
!#else
!#define NntpAuthenticate NntpAuthenticateA
!#endif

!PUBLIC int WINAPI NntpGetCurrentDateW(LPWSTR, int);
!PUBLIC int WINAPI NntpGetCurrentDateA(LPSTR, int);
!#ifdef UNICODE
!#define NntpGetCurrentDate NntpGetCurrentDateW
!#else
!#define NntpGetCurrentDate NntpGetCurrentDateA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI NntpInitialize(LPCSTR, DWORD);
!PUBLIC HCLIENT WINAPI NntpAsyncConnect(LPCSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI NntpConnect(LPCSTR, UINT, UINT);
!PUBLIC int WINAPI NntpGetErrorString(int, LPSTR, int);
!PUBLIC int WINAPI NntpCommand(HCLIENT, LPCSTR, LPCSTR);
!PUBLIC int WINAPI NntpGetResultString(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI NntpListNewGroups(HCLIENT, LPCSTR);
!PUBLIC int WINAPI NntpSelectGroup(HCLIENT, LPCSTR);
!PUBLIC int WINAPI NntpGetGroupName(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI NntpGetGroupTitle(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI NntpGetArticleMessageId(HCLIENT, LONG, LPSTR, int);
!PUBLIC LONG WINAPI NntpGetMessageIdArticle(HCLIENT, LPCSTR);
!PUBLIC int WINAPI NntpGetArticleByMessageId(HCLIENT, LPCSTR);
!PUBLIC int WINAPI NntpAuthenticate(HCLIENT, LPCSTR, LPCSTR);
!PUBLIC int WINAPI NntpGetCurrentDate(LPSTR, int);

!#endif /* WIN32 */

Section('SocketTools NNTP')

        Module('csnwsl32.dll')
            NntpDisconnect(HCLIENT), Signed, Pascal
            NntpAsyncNotify(HCLIENT, HWND, Unsigned), Signed, Pascal
            NntpSetLastError(Signed), Pascal
            NntpGetLastError(), Signed, Pascal
            NntpGetSocket(HCLIENT), Socket, Pascal
            NntpReadResult(HCLIENT), Signed, Pascal
            NntpGetResultCode(HCLIENT), Signed, Pascal
            NntpRead(HCLIENT, LPBYTE, Signed), Signed, Pascal
            NntpWrite(HCLIENT, LPBYTE, Signed), Signed, Pascal
            NntpGetTimeout(HCLIENT), Signed, Pascal
            NntpSetTimeout(HCLIENT, Signed), Signed, Pascal
            NntpListGroups(HCLIENT), Signed, Pascal
            NntpGetArticleRange(HCLIENT, LPLONG, LPLONG), Long, Pascal
            NntpGetCurrentArticle(HCLIENT), Long, Pascal
            NntpListArticles(HCLIENT, LONG, LONG), Signed, Pascal
            NntpGetArticleHeader(HCLIENT, LONG), Signed, Pascal
            NntpGetArticleByNumber(HCLIENT, LONG), Signed, Pascal
            NntpGetNextArticle(HCLIENT), Signed, Pascal
            NntpGetPreviousArticle(HCLIENT), Signed, Pascal
            NntpCreateArticle(HCLIENT), Signed, Pascal
            NntpCloseArticle(HCLIENT), Signed, Pascal
            NntpIsBlocking(HCLIENT), BOOL, Pascal
            NntpCancel(HCLIENT), Signed, Pascal
            NntpSetMultiLine(HCLIENT, BOOL), Signed, Pascal
            NntpGetMultiLine(HCLIENT, *BOOL), Signed, Pascal, Raw
            NntpUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                NntpInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('NntpInitializeA')
                NntpAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal, Name('NntpAsyncConnectA')
                NntpConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal, Name('NntpConnectA')
                NntpGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('NntpGetErrorStringA')
                NntpCommand(HCLIENT, *CString, *CString), Signed, Raw, Pascal, Name('NntpCommandA')
                NntpGetResultString(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('NntpGetResultStringA')
                NntpListNewGroups(HCLIENT, *CString), Signed, Raw, Pascal, Name('NntpListNewGroupsA')
                NntpSelectGroup(HCLIENT, *CString), Signed, Raw, Pascal, Name('NntpSelectGroupA')
                NntpGetGroupName(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('NntpGetGroupNameA')
                NntpGetGroupTitle(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('NntpGetGroupTitleA')
                NntpGetArticleMessageId(HCLIENT, LONG, *CString, Signed), Signed, Raw, Pascal, Name('NntpGetArticleMessageIdA')
                NntpGetMessageIdArticle(HCLIENT, *CString), Long, Raw, Pascal, Name('NntpGetMessageIdArticleA')
                NntpGetArticleByMessageId(HCLIENT, *CString), Signed, Raw, Pascal, Name('NntpGetArticleByMessageIdA')
                NntpAuthenticate(HCLIENT, *CString, *CString), Signed, Raw, Pascal, Name('NntpAuthenticateA')
                NntpGetCurrentDate(*CString, Signed), Signed, Raw, Pascal, Name('NntpGetCurrentDateA')
            ***
            Omit('***', _WIDTH32_ )
                NntpInitialize(*CString, DWORD), BOOL, Raw, Pascal
                NntpAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal
                NntpConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal
                NntpGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
                NntpCommand(HCLIENT, *CString, *CString), Signed, Raw, Pascal
                NntpGetResultString(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                NntpListNewGroups(HCLIENT, *CString), Signed, Raw, Pascal
                NntpSelectGroup(HCLIENT, *CString), Signed, Raw, Pascal
                NntpGetGroupName(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                NntpGetGroupTitle(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                NntpGetArticleMessageId(HCLIENT, LONG, *CString, Signed), Signed, Raw, Pascal
                NntpGetMessageIdArticle(HCLIENT, *CString), Long, Raw, Pascal
                NntpGetArticleByMessageId(HCLIENT, *CString), Signed, Raw, Pascal
                NntpAuthenticate(HCLIENT, *CString, *CString), Signed, Raw, Pascal
                NntpGetCurrentDate(*CString, Signed), Signed, Raw, Pascal
            ***
        end   ! Module('SocketTools Network News Transfer Protocol (NNTP) Client Libraries')

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Post Office Protocol v3 (POP3) client libraries CSPOPL16.DLL
! * and CSPOPL32.DLL
! *
! ************************************************************************/

!PUBLIC int WINAPI PopDisconnect(HCLIENT);
!PUBLIC int WINAPI PopAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC VOID WINAPI PopSetLastError(int);
!PUBLIC int WINAPI PopGetLastError(VOID);
!PUBLIC SOCKET WINAPI PopGetSocket(HCLIENT);
!PUBLIC BOOL WINAPI PopReadResult(HCLIENT);
!PUBLIC BOOL WINAPI PopGetResultCode(HCLIENT);
!PUBLIC int WINAPI PopRead(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI PopGetTimeout(HCLIENT);
!PUBLIC int WINAPI PopSetTimeout(HCLIENT, int);
!PUBLIC int WINAPI PopGetMessageCount(HCLIENT);
!PUBLIC int WINAPI PopGetMessage(HCLIENT, UINT, LPDWORD);
!PUBLIC int WINAPI PopGetMessageHeader(HCLIENT, UINT, LPDWORD);
!PUBLIC int WINAPI PopDeleteMessage(HCLIENT, UINT);
!PUBLIC BOOL WINAPI PopReset(HCLIENT);
!PUBLIC BOOL WINAPI PopIsBlocking(HCLIENT);
!PUBLIC int WINAPI PopCancel(HCLIENT);
!PUBLIC int WINAPI PopSetMultiLine(HCLIENT, BOOL);
!PUBLIC int WINAPI PopGetMultiLine(HCLIENT, BOOL FAR *);
!PUBLIC VOID WINAPI PopUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI PopInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI PopInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define PopInitialize PopInitializeW
!#else
!#define PopInitialize PopInitializeA
!#endif

!PUBLIC int WINAPI PopGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI PopGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define PopGetErrorString PopGetErrorStringW
!#else
!#define PopGetErrorString PopGetErrorStringA
!#endif

!PUBLIC HCLIENT WINAPI PopAsyncConnectW(LPCWSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI PopAsyncConnectA(LPCSTR, UINT, UINT, HWND, UINT);
!#ifdef UNICODE
!#define PopAsyncConnect PopAsyncConnectW
!#else
!#define PopAsyncConnect PopAsyncConnectA
!#endif

!PUBLIC HCLIENT WINAPI PopConnectW(LPCWSTR, UINT, UINT);
!PUBLIC HCLIENT WINAPI PopConnectA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define PopConnect PopConnectW
!#else
!#define PopConnect PopConnectA
!#endif

!PUBLIC BOOL WINAPI PopCommandW(HCLIENT, LPCWSTR, LPCWSTR);
!PUBLIC BOOL WINAPI PopCommandA(HCLIENT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define PopCommand PopCommandW
!#else
!#define PopCommand PopCommandA
!#endif

!PUBLIC int WINAPI PopGetResultStringW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI PopGetResultStringA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define PopGetResultString PopGetResultStringW
!#else
!#define PopGetResultString PopGetResultStringA
!#endif

!PUBLIC BOOL WINAPI PopLoginW(HCLIENT, LPCWSTR, LPCWSTR);
!PUBLIC BOOL WINAPI PopLoginA(HCLIENT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define PopLogin PopLoginW
!#else
!#define PopLogin PopLoginA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI PopInitialize(LPCSTR, DWORD);
!PUBLIC int WINAPI PopGetErrorString(int, LPSTR, int);
!PUBLIC HCLIENT WINAPI PopAsyncConnect(LPCSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI PopConnect(LPCSTR, UINT, UINT);
!PUBLIC BOOL WINAPI PopCommand(HCLIENT, LPCSTR, LPCSTR);
!PUBLIC int WINAPI PopGetResultString(HCLIENT, LPSTR, int);
!PUBLIC BOOL WINAPI PopLogin(HCLIENT, LPCSTR, LPCSTR);

!#endif /* WIN32 */

Section('SocketTools POP3')

        Module('cspopl32.dll')
            PopDisconnect(HCLIENT), Signed, Pascal
            PopAsyncNotify(HCLIENT, HWND, Unsigned), Signed, Pascal
            PopSetLastError(Signed), Pascal
            PopGetLastError(), Signed, Pascal
            PopGetSocket(HCLIENT), long, Pascal
            PopReadResult(HCLIENT), BOOL, Pascal
            PopGetResultCode(HCLIENT), BOOL, Pascal
            PopSync(HCLIENT), BOOL, Pascal
            PopRead(HCLIENT, LPBYTE, Signed), Signed, Pascal
            PopGetTimeout(HCLIENT), Signed, Pascal
            PopSetTimeout(HCLIENT, Signed), Signed, Pascal
            PopSetLineMode(HCLIENT, Unsigned), Signed, Pascal
            PopGetLineMode(HCLIENT, *Unsigned), Signed, Pascal
            PopGetMessageCount(HCLIENT), Signed, Pascal
            PopGetMessage(HCLIENT, Unsigned, LPDWORD), Signed, Pascal
            PopGetMessageHeader(HCLIENT, Unsigned, LPDWORD), Signed, Pascal
            PopDeleteMessage(HCLIENT, Unsigned), Signed, Pascal
            PopReset(HCLIENT), BOOL, Pascal
            PopIsBlocking(HCLIENT), BOOL, Pascal
            PopCancel(HCLIENT), Signed, Pascal
            PopSetMultiLine(HCLIENT, BOOL), Signed, Pascal
            PopGetMultiLine(HCLIENT, *BOOL), Signed, Pascal
            PopUninitialize(), Pascal, Raw
            Omit('***', _WIDTH32_ )
                PopInitialize(*CString, DWORD), Bool, Raw, Pascal
                PopGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
                PopAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal
                PopConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal
                PopCommand(HCLIENT, *CString, *CString), BOOL, Raw, Pascal
                PopGetResultString(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                PopLogin(HCLIENT, *CString, *CString), BOOL, Raw, Pascal
            ***
            Compile('***', _WIDTH32_ )
                PopInitialize(*CString, DWORD), Bool, Raw, Pascal, Name('PopInitializeA')
                PopGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('PopGetErrorStringA')
                PopAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal, Name('PopAsyncConnectA')
                PopConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal, Name('PopConnectA')
                PopCommand(HCLIENT, *CString, *CString), BOOL, Raw, Pascal, Name('PopCommandA')
                PopGetResultString(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('PopGetResultStringA')
                PopLogin(HCLIENT, *CString, *CString), BOOL, Raw, Pascal, Name('PopLoginA')
            ***
        end ! Module('SocketTools POP3 client libraries')

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Remote Command libraries CSREXL16.DLL and CSREXL32.DLL
! *
! ************************************************************************/

!PUBLIC VOID WINAPI RlibSetLastError(int);
!PUBLIC int WINAPI RlibGetLastError(VOID);
!PUBLIC int WINAPI RlibDisconnect(HCLIENT);
!PUBLIC int WINAPI RlibRead(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI RlibWrite(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI RlibAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC int WINAPI RlibGetTimeout(HCLIENT);
!PUBLIC int WINAPI RlibSetTimeout(HCLIENT, int);
!PUBLIC SOCKET WINAPI RlibGetSocket(HCLIENT);
!PUBLIC VOID WINAPI RlibUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI RlibInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI RlibInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define RlibInitialize RlibInitializeW
!#else
!#define RlibInitialize RlibInitializeA
!#endif

!PUBLIC int WINAPI RlibGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI RlibGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define RlibGetErrorString RlibGetErrorStringW
!#else
!#define RlibGetErrorString RlibGetErrorStringA
!#endif

!PUBLIC HCLIENT WINAPI RlibRemoteExecuteW(LPCWSTR, UINT, UINT, LPCWSTR, LPCWSTR, LPCWSTR);
!PUBLIC HCLIENT WINAPI RlibRemoteExecuteA(LPCSTR, UINT, UINT, LPCSTR, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define RlibRemoteExecute RlibRemoteExecuteW
!#else
!#define RlibRemoteExecute RlibRemoteExecuteA
!#endif

!PUBLIC HCLIENT WINAPI RlibRemoteCommandW(LPCWSTR, UINT, UINT, LPCWSTR, LPCWSTR);
!PUBLIC HCLIENT WINAPI RlibRemoteCommandA(LPCSTR, UINT, UINT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define RlibRemoteCommand RlibRemoteCommandW
!#else
!#define RlibRemoteCommand RlibRemoteCommandA
!#endif

!PUBLIC HCLIENT WINAPI RlibRemoteLoginW(LPCWSTR, UINT, UINT, LPCWSTR, LPCWSTR);
!PUBLIC HCLIENT WINAPI RlibRemoteLoginA(LPCSTR, UINT, UINT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define RlibRemoteLogin RlibRemoteLoginW
!#else
!#define RlibRemoteLogin RlibRemoteLoginA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI RlibInitialize(LPCSTR, DWORD);
!PUBLIC int WINAPI RlibGetErrorString(int, LPSTR, int);
!PUBLIC HCLIENT WINAPI RlibRemoteExecute(LPCSTR, UINT, UINT, LPCSTR, LPCSTR, LPCSTR);
!PUBLIC HCLIENT WINAPI RlibRemoteCommand(LPCSTR, UINT, UINT, LPCSTR, LPCSTR);
!PUBLIC HCLIENT WINAPI RlibRemoteLogin(LPCSTR, UINT, UINT, LPCSTR, LPCSTR);

!#endif /* WIN32 */

Section('SocketTools Remote Command')

        Module('csrexl32.dll')
            RlibSetLastError(Signed), Pascal
            RlibGetLastError(), Signed, Pascal
            RlibDisconnect(HCLIENT), Signed, Pascal
            RlibRead(HCLIENT, LPBYTE, Signed), Signed, Pascal
            RlibWrite(HCLIENT, LPBYTE, Signed), Signed, Pascal
            RlibAsyncNotify(HCLIENT, HWND, Unsigned), Signed, Pascal
            RlibGetTimeout(HCLIENT), Signed, Pascal
            RlibSetTimeout(HCLIENT, Signed), Signed, Pascal
            RlibGetSocket(HCLIENT), Socket, Pascal
            RlibUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                RlibInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('RlibInitializeA')
                RlibGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('RlibGetErrorStringA')
                RlibRemoteExecute(*CString, Unsigned, Unsigned, *CString, *CString, *CString), HCLIENT, Raw, Pascal, Name('RlibRemoteExecuteA')
                RlibRemoteCommand(*CString, Unsigned, Unsigned, *CString, *CString), HCLIENT, Raw, Pascal, Name('RlibRemoteCommandA')
                RlibRemoteLogin(*CString, Unsigned, Unsigned, *CString, *CString), HCLIENT, Raw, Pascal, Name('RlibRemoteLoginA')
            ***
            Omit('***', _WIDTH32_ )
                RlibInitialize(*CString, DWORD), BOOL, Raw, Pascal
                RlibGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
                RlibRemoteExecute(*CString, Unsigned, Unsigned, *CString, *CString, *CString), HCLIENT, Raw, Pascal
                RlibRemoteCommand(*CString, Unsigned, Unsigned, *CString, *CString), HCLIENT, Raw, Pascal
                RlibRemoteLogin(*CString, Unsigned, Unsigned, *CString, *CString), HCLIENT, Raw, Pascal
            ***
        end   ! Module('SocketTools Remote Command libraries')

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Simple Mail Transfer Protocol (SMTP) client libraries
! * CSMTPL16.DLL and CSMTPL32.DLL
! *
! ************************************************************************/

!PUBLIC int WINAPI SmtpDisconnect(HCLIENT);
!PUBLIC int WINAPI SmtpAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC VOID WINAPI SmtpSetLastError(int);
!PUBLIC int WINAPI SmtpGetLastError(VOID);
!PUBLIC SOCKET WINAPI SmtpGetSocket(HCLIENT);
!PUBLIC int WINAPI SmtpGetResultCode(HCLIENT);
!PUBLIC int WINAPI SmtpGetTimeout(HCLIENT);
!PUBLIC int WINAPI SmtpSetTimeout(HCLIENT, int);
!PUBLIC BOOL WINAPI SmtpIsBlocking(HCLIENT);
!PUBLIC int WINAPI SmtpCancel(HCLIENT);
!PUBLIC int WINAPI SmtpReset(HCLIENT);
!PUBLIC int WINAPI SmtpWrite(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI SmtpEndMessage(HCLIENT);
!PUBLIC VOID WINAPI SmtpUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI SmtpInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI SmtpInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define SmtpInitialize SmtpInitializeW
!#else
!#define SmtpInitialize SmtpInitializeA
!#endif

!PUBLIC HCLIENT WINAPI SmtpAsyncConnectW(LPCWSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI SmtpAsyncConnectA(LPCSTR, UINT, UINT, HWND, UINT);
!#ifdef UNICODE
!#define SmtpAsyncConnect SmtpAsyncConnectW
!#else
!#define SmtpAsyncConnect SmtpAsyncConnectA
!#endif

!PUBLIC HCLIENT WINAPI SmtpConnectW(LPCWSTR, UINT, UINT);
!PUBLIC HCLIENT WINAPI SmtpConnectA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define SmtpConnect SmtpConnectW
!#else
!#define SmtpConnect SmtpConnectA
!#endif

!PUBLIC int WINAPI SmtpGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI SmtpGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define SmtpGetErrorString SmtpGetErrorStringW
!#else
!#define SmtpGetErrorString SmtpGetErrorStringA
!#endif

!PUBLIC int WINAPI SmtpCommandW(HCLIENT, LPCWSTR, LPCWSTR);
!PUBLIC int WINAPI SmtpCommandA(HCLIENT, LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define SmtpCommand SmtpCommandW
!#else
!#define SmtpCommand SmtpCommandA
!#endif

!PUBLIC int WINAPI SmtpGetResultStringW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI SmtpGetResultStringA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define SmtpGetResultString SmtpGetResultStringW
!#else
!#define SmtpGetResultString SmtpGetResultStringA
!#endif

!PUBLIC int WINAPI SmtpHelloW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI SmtpHelloA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define SmtpHello SmtpHelloW
!#else
!#define SmtpHello SmtpHelloA
!#endif

!PUBLIC int WINAPI SmtpExpandAddressW(HCLIENT, LPCWSTR, LPWSTR, int);
!PUBLIC int WINAPI SmtpExpandAddressA(HCLIENT, LPCSTR, LPSTR, int);
!#ifdef UNICODE
!#define SmtpExpandAddress SmtpExpandAddressW
!#else
!#define SmtpExpandAddress SmtpExpandAddressA
!#endif

!PUBLIC int WINAPI SmtpVerifyAddressW(HCLIENT, LPCWSTR, LPWSTR, int);
!PUBLIC int WINAPI SmtpVerifyAddressA(HCLIENT, LPCSTR, LPSTR, int);
!#ifdef UNICODE
!#define SmtpVerifyAddress SmtpVerifyAddressW
!#else
!#define SmtpVerifyAddress SmtpVerifyAddressA
!#endif

!PUBLIC int WINAPI SmtpBeginMessageW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI SmtpBeginMessageA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define SmtpBeginMessage SmtpBeginMessageW
!#else
!#define SmtpBeginMessage SmtpBeginMessageA
!#endif

!PUBLIC int WINAPI SmtpAddRecipientW(HCLIENT, LPCWSTR);
!PUBLIC int WINAPI SmtpAddRecipientA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define SmtpAddRecipient SmtpAddRecipientW
!#else
!#define SmtpAddRecipient SmtpAddRecipientA
!#endif

!PUBLIC int WINAPI SmtpGetCurrentDateW(LPWSTR, int);
!PUBLIC int WINAPI SmtpGetCurrentDateA(LPSTR, int);
!#ifdef UNICODE
!#define SmtpGetCurrentDate SmtpGetCurrentDateW
!#else
!#define SmtpGetCurrentDate SmtpGetCurrentDateA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI SmtpInitialize(LPCSTR, DWORD);
!PUBLIC HCLIENT WINAPI SmtpAsyncConnect(LPCSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI SmtpConnect(LPCSTR, UINT, UINT);
!PUBLIC int WINAPI SmtpGetErrorString(int, LPSTR, int);
!PUBLIC int WINAPI SmtpCommand(HCLIENT, LPCSTR, LPCSTR);
!PUBLIC int WINAPI SmtpGetResultString(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI SmtpHello(HCLIENT, LPCSTR);
!PUBLIC int WINAPI SmtpExpandAddress(HCLIENT, LPCSTR, LPSTR, int);
!PUBLIC int WINAPI SmtpVerifyAddress(HCLIENT, LPCSTR, LPSTR, int);
!PUBLIC int WINAPI SmtpBeginMessage(HCLIENT, LPCSTR);
!PUBLIC int WINAPI SmtpAddRecipient(HCLIENT, LPCSTR);
!PUBLIC int WINAPI SmtpGetCurrentDate(LPSTR, int);

!#endif /* WIN32 */

Section('SocketTools SMTP')

        Module('csmtpl32.dll')
            SmtpDisconnect(HCLIENT), Signed, Pascal
            SmtpAsyncNotify(HCLIENT, HWND, Unsigned), Signed, Pascal
            SmtpSetLastError(Signed), Pascal
            SmtpGetLastError(), Signed, Pascal
            SmtpGetSocket(HCLIENT), Socket, Pascal
            SmtpGetResultCode(HCLIENT), Signed, Pascal
            SmtpHookResult(HCLIENT, FARPROC, LPARAM), Signed, Pascal
            SmtpSync(HCLIENT), Signed, Pascal
            SmtpGetTimeout(HCLIENT), Signed, Pascal
            SmtpSetTimeout(HCLIENT, Signed), Signed, Pascal
            SmtpIsBlocking(HCLIENT), BOOL, Pascal
            SmtpCancel(HCLIENT), Signed, Pascal
            SmtpReset(HCLIENT), Signed, Pascal
            SmtpWrite(HCLIENT, LPBYTE, Signed), Signed, Pascal
            SmtpEndMessage(HCLIENT), Signed, Pascal
            SmtpUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                SmtpInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('SmtpInitializeA')
                SmtpAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal, Name('SmtpAsyncConnectA')
                SmtpConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal, Name('SmtpConnectA')
                SmtpGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('SmtpGetErrorStringA')
                SmtpCommand(HCLIENT, *CString, *CString), Signed, Raw, Pascal, Name('SmtpCommandA')
                SmtpGetResultString(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('SmtpGetResultStringA')
                SmtpHello(HCLIENT, *CString), Signed, Raw, Pascal, Name('SmtpHelloA')
                SmtpExpandAddress(HCLIENT, *CString, *CString, Signed), Signed, Raw, Pascal, Name('SmtpExpandAddressA')
                SmtpVerifyAddress(HCLIENT, *CString, *CString, Signed), Signed, Raw, Pascal, Name('SmtpVerifyAddressA')
                SmtpBeginMessage(HCLIENT, *CString), Signed, Raw, Pascal, Name('SmtpBeginMessageA')
                SmtpAddRecipient(HCLIENT, *CString), Signed, Raw, Pascal, Name('SmtpAddRecipientA')
                SmtpGetCurrentDate(*CString, Signed), Signed, Raw, Pascal, Name('SmtpGetCurrentDateA')
            ***
            Omit('***', _WIDTH32_ )
                SmtpInitialize(*CString, DWORD), BOOL, Raw, Pascal
                SmtpAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal
                SmtpConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal
                SmtpGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
                SmtpCommand(HCLIENT, *CString, *CString), Signed, Raw, Pascal
                SmtpGetResultString(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                SmtpHello(HCLIENT, *CString), Signed, Raw, Pascal
                SmtpExpandAddress(HCLIENT, *CString, *CString, Signed), Signed, Raw, Pascal
                SmtpVerifyAddress(HCLIENT, *CString, *CString, Signed), Signed, Raw, Pascal
                SmtpBeginMessage(HCLIENT, *CString), Signed, Raw, Pascal
                SmtpAddRecipient(HCLIENT, *CString), Signed, Raw, Pascal
                SmtpGetCurrentDate(*CString, Signed), Signed, Raw, Pascal
            ***
        end   ! Module('SocketTools Simple Mail Transfer Protocol (SMTP) client libraries')
!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Windows Socket (SocketWrench) libraries CSTCPL16.DLL and
! * CSTCPL32.DLL
! *
! *************************************************************************/

Section('SocketTools SocketWrench Libraries')


        Module ('cstcpl32.dll')
            InetAccept(Socket, unsigned), Socket, Raw, Pascal
            InetAsyncAccept(Socket, unsigned, HWND, unsigned), signed, pascal
            InetAsyncListen(DWORD, unsigned, HWND, unsigned), Socket, raw, pascal
            InetAsyncNotify(Socket, HWND, unsigned), signed, pascal
            InetDisconnect(Socket), signed, pascal
            InetFlush(Socket), signed, pascal
            InetGetLastError(), signed, pascal
!           InetGetLocalAddress(Socket,DWORD, unsigned), signed, pascal
!           InetGetOption(Socket, DWORD, *BOOL), signed, pascal
!           InetGetPeerAddress(Socket, DWORD, unsigned), signed, pascal
            InetListen(DWORD, unsigned), signed, pascal
            InetRead(Socket, LPBYTE, signed), signed, pascal
            InetSetLastError(signed),raw, pascal
            InetSetOption(Socket, DWORD, Bool), signed, pascal
            InetUninitialize(), raw, pascal
            InetWrite(Socket, LPBYTE, signed), signed, pascal
            Compile('***', _WIDTH32_)
                InetAsyncConnect(*CString, unsigned, unsigned, unsigned, HWND, unsigned), socket, raw, pascal, name('InetAsyncConnectA')
                InetAsyncConnectEx(*CString, unsigned, unsigned, unsigned, DWORD, DWORD, unsigned, HWND, unsigned), socket, raw, name('InetAsyncConnectExA')
                InetConnect(*CString, unsigned, unsigned, unsigned), socket, raw, pascal, name('InetConnectA')
                InetConnectEx(*Cstring, unsigned, unsigned, unsigned, DWORD, DWORD, unsigned), socket, raw, pascal, name('InetConnectExA')
                InetFormatAddress(DWORD, LPTSTR, signed), signed, pascal, name('InetFormatAddressA')
                InetGetErrorString(signed, LPTSTR, signed), signed, pascal, name('InetGetErrorStringA')
                InetGetHostAddress(*CString),DWORD, raw, pascal, name('InetGetHostAddressA')
                InetGetHostName(DWORD, LPTSTR, signed), signed, pascal, name('InetGetHostNameA')
                InetGetLocalName(LPTSTR, signed), signed, pascal, name('InetGetLocalNameA')
            ***
            Omit('***', _WIDTH32_)
                InetAsyncConnect(*CString, unsigned, unsigned, unsigned, HWND, unsigned), socket, raw, pascal
                InetAsyncConnectEx(*CString, unsigned, unsigned, unsigned, DWORD, DWORD, unsigned, HWND, unsigned), socket, raw, pascal
                InetConnect(*Cstring, unsigned, unsigned, unsigned), socket, raw, pascal
                InetConnectEx(*CString, unsigned, unsigned, unsigned, DWORD, DWORD, unsigned), socket, raw, pascal
                InetFormatAddress(DWORD, LPTSTR, signed), signed, pascal
                InetGetErrorString(signed, lptstr, signed), signed, pascal
                InetGetHostAddress(*CString), ulong, raw, pascal
                InetGetHostName(DWORD, LPTSTR, signed), signed, pascal
                InetGetLocalName(LPTSTR, signed), signed, pascal
            ***
        end     ! Module ('SocketTools SocketWrench Library')



!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Telnet client libraries CSTNTL16.DLL and CSTNTL32.DLL
! *
! ************************************************************************/

!PUBLIC BOOL WINAPI TelnetDisconnect(HCLIENT);
!PUBLIC BOOL WINAPI TelnetCancel(HCLIENT);
!PUBLIC BOOL WINAPI TelnetAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC int WINAPI TelnetRead(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI TelnetWrite(HCLIENT, LPBYTE, int);
!PUBLIC BOOL WINAPI TelnetBreak(HCLIENT);
!PUBLIC BOOL WINAPI TelnetIsThere(HCLIENT);
!PUBLIC BOOL WINAPI TelnetIsBlocking(HCLIENT);
!PUBLIC UINT WINAPI TelnetGetMode(HCLIENT);
!PUBLIC UINT WINAPI TelnetSetMode(HCLIENT, UINT, BOOL);
!PUBLIC int WINAPI TelnetGetTimeout(HCLIENT);
!PUBLIC int WINAPI TelnetSetTimeout(HCLIENT, int);
!PUBLIC VOID WINAPI TelnetSetLastError(int);
!PUBLIC int WINAPI TelnetGetLastError(VOID);
!PUBLIC SOCKET WINAPI TelnetGetSocket(HCLIENT);
!PUBLIC VOID WINAPI TelnetUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI TelnetInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI TelnetInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define TelnetInitialize TelnetInitializeW
!#else
!#define TelnetInitialize TelnetInitializeA
!#endif

!PUBLIC HCLIENT WINAPI TelnetAsyncConnectW(LPCWSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI TelnetAsyncConnectA(LPCSTR, UINT, UINT, HWND, UINT);
!#ifdef UNICODE
!#define TelnetAsyncConnect TelnetAsyncConnectW
!#else
!#define TelnetAsyncConnect TelnetAsyncConnectA
!#endif

!PUBLIC HCLIENT WINAPI TelnetConnectW(LPCWSTR, UINT, UINT);
!PUBLIC HCLIENT WINAPI TelnetConnectA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define TelnetConnect TelnetConnectW
!#else
!#define TelnetConnect TelnetConnectA
!#endif

!PUBLIC BOOL WINAPI TelnetSetTerminalTypeW(HCLIENT, LPCWSTR);
!PUBLIC BOOL WINAPI TelnetSetTerminalTypeA(HCLIENT, LPCSTR);
!#ifdef UNICODE
!#define TelnetSetTerminalType TelnetSetTerminalTypeW
!#else
!#define TelnetSetTerminalType TelnetSetTerminalTypeA
!#endif

!PUBLIC int WINAPI TelnetGetTerminalTypeW(HCLIENT, LPWSTR, int);
!PUBLIC int WINAPI TelnetGetTerminalTypeA(HCLIENT, LPSTR, int);
!#ifdef UNICODE
!#define TelnetGetTerminalType TelnetGetTerminalTypeW
!#else
!#define TelnetGetTerminalType TelnetGetTerminalTypeA
!#endif

!PUBLIC int WINAPI TelnetGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI TelnetGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define TelnetGetErrorString TelnetGetErrorStringW
!#else
!#define TelnetGetErrorString TelnetGetErrorStringA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI TelnetInitialize(LPCSTR, DWORD);
!PUBLIC HCLIENT WINAPI TelnetAsyncConnect(LPCSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI TelnetConnect(LPCSTR, UINT, UINT);
!PUBLIC BOOL WINAPI TelnetSetTerminalType(HCLIENT, LPCSTR);
!PUBLIC int WINAPI TelnetGetTerminalType(HCLIENT, LPSTR, int);
!PUBLIC int WINAPI TelnetGetErrorString(int, LPSTR, int);

!#endif /* WIN32 */

Section('SocketTools Telnet client')

        Module('cstntl32.dll')
            TelnetDisconnect(HCLIENT), BOOL, Pascal
            TelnetCancel(HCLIENT), BOOL, Pascal
            TelnetAsyncNotify(HCLIENT, HWND, Unsigned), BOOL, Pascal
            TelnetRead(HCLIENT, LPBYTE, Signed), Signed, Pascal
            TelnetWrite(HCLIENT, LPBYTE, Signed), Signed, Pascal
            TelnetBreak(HCLIENT), BOOL, Pascal
            TelnetIsThere(HCLIENT), BOOL, Pascal
            TelnetIsBlocking(HCLIENT), BOOL, Pascal
            TelnetIsClosed(HCLIENT), BOOL, Pascal
            TelnetGetMode(HCLIENT), UnSigned, Pascal
            TelnetSetMode(HCLIENT, Unsigned, BOOL), UnSigned, Pascal
            TelnetGetTimeout(HCLIENT), Signed, Pascal
            TelnetSetTimeout(HCLIENT, Signed), Signed, Pascal
            TelnetSetLastError(Signed), Pascal
            TelnetGetLastError(), Signed, Pascal
            TelnetGetSocket(HCLIENT), Socket, Pascal
            TelnetUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                TelnetInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('TelnetInitializeA')
                TelnetAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal, Name('TelnetAsyncConnectA')
                TelnetConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal, Name('TelnetConnectA')
                TelnetSetTerminalType(HCLIENT, *CString), BOOL, Raw, Pascal, Name('TelnetSetTerminalTypeA')
                TelnetGetTerminalType(HCLIENT, *CString, Signed), Signed, Raw, Pascal, Name('TelnetGetTerminalTypeA')
                TelnetGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('TelnetGetErrorStringA')
            ***
            Omit('***', _WIDTH32_ )
                TelnetInitialize(*CString, DWORD), BOOL, Raw, Pascal
                TelnetAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal
                TelnetConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal
                TelnetSetTerminalType(HCLIENT, *CString), BOOL, Raw, Pascal
                TelnetGetTerminalType(HCLIENT, *CString, Signed), Signed, Raw, Pascal
                TelnetGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
            ***
        end   ! Module('SocketTools Telnet client libraries')

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Telnet virtual terminal libraries CSNVTL16.DLL and CSNVTL32.DLL
! *
! ************************************************************************/

!PUBLIC HDISPLAY WINAPI NvtCreateDisplay(HWND, HFONT, UINT, UINT, UINT);
!PUBLIC VOID WINAPI NvtDestroyDisplay(HDISPLAY);
!PUBLIC BOOL WINAPI NvtResetDisplay(HDISPLAY, HWND, HFONT, UINT, UINT);
!PUBLIC BOOL WINAPI NvtSetDisplayWindow(HDISPLAY, HWND);
!PUBLIC HWND WINAPI NvtGetDisplayWindow(HDISPLAY);
!PUBLIC BOOL WINAPI NvtSetDisplayDC(HDISPLAY, HDC);
!PUBLIC HDC WINAPI NvtGetDisplayDC(HDISPLAY);
!PUBLIC BOOL WINAPI NvtSetDisplayEmulation(HDISPLAY, UINT);
!PUBLIC UINT WINAPI NvtGetDisplayEmulation(HDISPLAY);
!PUBLIC BOOL WINAPI NvtSetDisplayFocus(HDISPLAY, BOOL);
!PUBLIC BOOL WINAPI NvtSetDisplayFont(HDISPLAY, HFONT);
!PUBLIC HFONT WINAPI NvtGetDisplayFont(HDISPLAY);
!PUBLIC BOOL WINAPI NvtSetDisplayBackColor(HDISPLAY, COLORREF);
!PUBLIC BOOL WINAPI NvtSetDisplayBoldColor(HDISPLAY, COLORREF);
!PUBLIC BOOL WINAPI NvtSetDisplayForeColor(HDISPLAY, COLORREF);
!PUBLIC BOOL WINAPI NvtSetDisplayColor(HDISPLAY, UINT, COLORREF, BOOL);
!PUBLIC COLORREF WINAPI NvtGetDisplayColor(HDISPLAY, UINT, BOOL);
!PUBLIC BOOL WINAPI NvtGetDisplayRect(HDISPLAY, LPRECT);
!PUBLIC BOOL WINAPI NvtSetDisplayMode(HDISPLAY, UINT, BOOL);
!PUBLIC UINT WINAPI NvtGetDisplayMode(HDISPLAY);
!PUBLIC BOOL WINAPI NvtSetDisplayScrollPos(HDISPLAY, int, int);
!PUBLIC int WINAPI NvtGetDisplayScrollPos(HDISPLAY, int);
!PUBLIC BOOL WINAPI NvtGetDisplayInfo(HDISPLAY, LPNVTDISPLAYINFO);
!PUBLIC BOOL WINAPI NvtSetDisplayPos(HDISPLAY, int, int);
!PUBLIC BOOL WINAPI NvtGetDisplayPos(HDISPLAY, LPPOINT);
!PUBLIC BOOL WINAPI NvtClearDisplay(HDISPLAY, UINT);
!PUBLIC BOOL WINAPI NvtEraseLine(HDISPLAY, UINT);
!PUBLIC BOOL WINAPI NvtInsertLine(HDISPLAY);
!PUBLIC BOOL WINAPI NvtDeleteLine(HDISPLAY);
!PUBLIC BOOL WINAPI NvtDeleteChar(HDISPLAY, int);
!PUBLIC BOOL WINAPI NvtInsertChar(HDISPLAY, int);
!PUBLIC BOOL WINAPI NvtEraseChar(HDISPLAY, int);
!PUBLIC BOOL WINAPI NvtSaveCursor(HDISPLAY);
!PUBLIC BOOL WINAPI NvtRestoreCursor(HDISPLAY);
!PUBLIC BOOL WINAPI NvtResizeDisplay(HDISPLAY, int, int);
!PUBLIC BOOL WINAPI NvtRefreshDisplay(HDISPLAY, BOOL);
!PUBLIC BOOL WINAPI NvtScrollDisplay(HDISPLAY, BOOL);
!PUBLIC BOOL WINAPI NvtAdjustDisplay(HDISPLAY);
!PUBLIC BOOL WINAPI NvtWriteDisplay(HDISPLAY, LPBYTE, int);
!PUBLIC BOOL WINAPI NvtUpdateCaret(HDISPLAY);
!PUBLIC BOOL WINAPI NvtUpdateDisplay(HDISPLAY);
!PUBLIC VOID WINAPI NvtUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI NvtInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI NvtInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define NvtInitialize NvtInitializeW
!#else
!#define NvtInitialize NvtInitializeA
!#endif

!PUBLIC int WINAPI NvtGetDisplayTextW(HDISPLAY, int, LPWSTR, int);
!PUBLIC int WINAPI NvtGetDisplayTextA(HDISPLAY, int, LPSTR, int);
!#ifdef UNICODE
!#define NvtGetDisplayText NvtGetDisplayTextW
!#else
!#define NvtGetDisplayText NvtGetDisplayTextA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI NvtInitialize(LPCSTR, DWORD);
!PUBLIC int WINAPI NvtGetDisplayText(HDISPLAY, int, LPSTR, int);

!#endif /* WIN32 */

Section('SocketTools Telnet terminal')


        Module('csnvtl32.dll')
            NvtCreateDisplay(HWND, HFONT, Unsigned, Unsigned, Unsigned), HDISPLAY, Pascal
            NvtDestroyDisplay(HDISPLAY), Pascal
            NvtResetDisplay(HDISPLAY, HWND, HFONT, Unsigned, Unsigned), BOOL, Pascal
            NvtSetDisplayWindow(HDISPLAY, HWND), BOOL, Pascal
            NvtGetDisplayWindow(HDISPLAY), long, Pascal
            NvtSetDisplayDC(HDISPLAY, HDC), BOOL, Pascal
            NvtGetDisplayDC(HDISPLAY), long, Pascal
            NvtSetDisplayEmulation(HDISPLAY, Unsigned), BOOL, Pascal
            NvtGetDisplayEmulation(HDISPLAY), UnSigned, Pascal
            NvtSetDisplayFocus(HDISPLAY, BOOL), BOOL, Pascal
            NvtSetDisplayFont(HDISPLAY, HFONT), BOOL, Pascal
            NvtGetDisplayFont(HDISPLAY), long, Pascal
            NvtSetDisplayBackColor(HDISPLAY, COLORREF), BOOL, Pascal
            NvtSetDisplayBoldColor(HDISPLAY, COLORREF), BOOL, Pascal
            NvtSetDisplayForeColor(HDISPLAY, COLORREF), BOOL, Pascal
            NvtSetDisplayColor(HDISPLAY, Unsigned, COLORREF, BOOL), BOOL, Pascal
            NvtGetDisplayColor(HDISPLAY, Unsigned, BOOL), ulong, Pascal
            NvtGetDisplayRect(HDISPLAY, LPRECT), BOOL, Pascal
            NvtSetDisplayMode(HDISPLAY, Unsigned, BOOL), BOOL, Pascal
            NvtGetDisplayMode(HDISPLAY), Unsigned, Pascal
            NvtSetDisplayScrollPos(HDISPLAY, Signed, Signed), BOOL, Pascal
            NvtGetDisplayScrollPos(HDISPLAY, Signed), Signed, Pascal
            NvtGetDisplayInfo(HDISPLAY, LPNVTDISPLAYINFO), BOOL, Pascal
            NvtSetDisplayPos(HDISPLAY, Signed, Signed), BOOL, Pascal
            NvtGetDisplayPos(HDISPLAY, LPPOINT), BOOL, Pascal
            NvtClearDisplay(HDISPLAY, Unsigned), BOOL, Pascal
            NvtEraseLine(HDISPLAY, Unsigned), BOOL, Pascal
            NvtInsertLine(HDISPLAY), BOOL, Pascal
            NvtDeleteLine(HDISPLAY), BOOL, Pascal
            NvtDeleteChar(HDISPLAY, Signed), BOOL, Pascal
            NvtInsertChar(HDISPLAY, Signed), BOOL, Pascal
            NvtEraseChar(HDISPLAY, Signed), BOOL, Pascal
            NvtSaveCursor(HDISPLAY), BOOL, Pascal
            NvtRestoreCursor(HDISPLAY), BOOL, Pascal
            NvtResizeDisplay(HDISPLAY, Signed, Signed), BOOL, Pascal
            NvtRefreshDisplay(HDISPLAY, BOOL), BOOL, Pascal
            NvtScrollDisplay(HDISPLAY, BOOL), BOOL, Pascal
            NvtAdjustDisplay(HDISPLAY), BOOL, Pascal
            NvtWriteDisplay(HDISPLAY, LPBYTE, Signed), BOOL, Pascal
            NvtUpdateCaret(HDISPLAY), BOOL, Pascal
            NvtUpdateDisplay(HDISPLAY), BOOL, Pascal
            NvtUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                NvtInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('NvtInitializeA')
                NvtGetDisplayText(HDISPLAY, Signed, *CString, Signed), Signed, Raw, Pascal, Name('NvtGetDisplayTextA')
                NvtPrintDisplay(HDISPLAY, *CString), BOOL, Raw, Pascal, Name('NvtPrintDisplayA')
            ***
            Omit('***', _WIDTH32_ )
                NvtInitialize(*CString, DWORD), BOOL, Raw, Pascal
                NvtGetDisplayText(HDISPLAY, Signed, *CString, Signed), Signed, Raw, Pascal
                NvtPrintDisplay(HDISPLAY, *CString), BOOL, Raw, Pascal
            ***
        end  ! Module('SocketTools Telnet virtual terminal libraries')
!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Network Time Protocol client libraries CSTIML16.DLL and
! * CSTIML32.DLL
! *
! ************************************************************************/

!PUBLIC DWORD WINAPI ReadNetworkTime(SOCKET);
!PUBLIC BOOL WINAPI ConvertNetworkTime(DWORD, BOOL, LPSYSTEMTIME);
!PUBLIC DWORD WINAPI ConvertSystemTime(LPSYSTEMTIME);
!PUBLIC BOOL WINAPI UpdateLocalTime(DWORD);
!PUBLIC VOID WINAPI TimeUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI TimeInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI TimeInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define TimeInitialize TimeInitializeW
!#else
!#define TimeInitialize TimeInitializeA
!#endif

!PUBLIC SOCKET WINAPI QueryNetworkTimeW(LPCWSTR, UINT, HWND, UINT);
!PUBLIC SOCKET WINAPI QueryNetworkTimeA(LPCSTR, UINT, HWND, UINT);
!#ifdef UNICODE
!#define QueryNetworkTime QueryNetworkTimeW
!#else
!#define QueryNetworkTime QueryNetworkTimeA
!#endif

!PUBLIC DWORD WINAPI GetNetworkTimeW(LPCWSTR, UINT, UINT);
!PUBLIC DWORD WINAPI GetNetworkTimeA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define GetNetworkTime GetNetworkTimeW
!#else
!#define GetNetworkTime GetNetworkTimeA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI TimeInitialize(LPCSTR, DWORD);
!PUBLIC SOCKET WINAPI QueryNetworkTime(LPCSTR, UINT, HWND, UINT);
!PUBLIC DWORD WINAPI GetNetworkTime(LPCSTR, UINT, UINT);

!#endif /* WIN32 */

Section('SocketTools Time Protocol')

        Module('cstiml32.dll')
            ReadNetworkTime(SOCKET), ulong, Pascal
            ConvertNetworkTime(DWORD, BOOL, LPSYSTEMTIME), BOOL, Pascal
            ConvertSystemTime(LPSYSTEMTIME), ulong, Pascal
            UpdateLocalTime(DWORD), BOOL, Pascal
            TimeUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                TimeInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('TimeInitializeA')
                QueryNetworkTime(*CString, Unsigned, HWND, Unsigned), long, Raw, Pascal, Name('QueryNetworkTimeA')
                GetNetworkTime(*CString, Unsigned, Unsigned), ulong, Raw, Pascal, Name('GetNetworkTimeA')
            ***
            Omit('***', _WIDTH32_ )
                TimeInitialize(*CString, DWORD), BOOL, Raw, Pascal
                QueryNetworkTime(*CString, Unsigned, HWND, Unsigned), long, Raw, Pascal
                GetNetworkTime(*CString, Unsigned, Unsigned), ulong, Raw, Pascal
            ***
        end   ! Module('SocketTools Network Time Protocol client libraries')


!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * encoding and decoding libraries UUCODE16.DLL and UUCODE32.DLL
! *
! ************************************************************************/

!PUBLIC int  WINAPI DecodeBase64(LPBYTE, int, LPBYTE, int, LPINT, LPINT);
!PUBLIC int  WINAPI EncodeBase64(LPBYTE, int, LPBYTE, int, LPINT, LPINT, LPINT);
!PUBLIC int  WINAPI EncodeBase64Done(LPINT, int, LPBYTE, int);

!#ifdef WIN32

!PUBLIC BOOL WINAPI DecodeFileW(LPCWSTR, LPCWSTR);
!PUBLIC BOOL WINAPI DecodeFileA(LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define DecodeFile DecodeFileW
!#else
!#define DecodeFile DecodeFileA
!#endif

!PUBLIC BOOL WINAPI EncodeFileW(LPCWSTR, LPCWSTR);
!PUBLIC BOOL WINAPI EncodeFileA(LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define EncodeFile EncodeFileW
!#else
!#define EncodeFile EncodeFileA
!#endif

!PUBLIC BOOL WINAPI DecodeBase64FileW(LPCWSTR, LPCWSTR);
!PUBLIC BOOL WINAPI DecodeBase64FileA(LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define DecodeBase64File DecodeBase64FileW
!#else
!#define DecodeBase64File DecodeBase64FileA
!#endif

!PUBLIC BOOL WINAPI EncodeBase64FileW(LPCWSTR, LPCWSTR);
!PUBLIC BOOL WINAPI EncodeBase64FileA(LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define EncodeBase64File EncodeBase64FileW
!#else
!#define EncodeBase64File EncodeBase64FileA
!#endif

!PUBLIC BOOL WINAPI DecodeQuotedFileW(LPCWSTR, LPCWSTR);
!PUBLIC BOOL WINAPI DecodeQuotedFileA(LPCSTR, LPCSTR);
!#ifdef UNICODE
!#define DecodeQuotedFile DecodeQuotedFileW
!#else
!#define DecodeQuotedFile DecodeQuotedFileA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI DecodeFile(LPCSTR, LPCSTR);
!PUBLIC BOOL WINAPI EncodeFile(LPCSTR, LPCSTR);
!PUBLIC BOOL WINAPI DecodeBase64File(LPCSTR, LPCSTR);
!PUBLIC BOOL WINAPI EncodeBase64File(LPCSTR, LPCSTR);
!PUBLIC BOOL WINAPI DecodeQuotedFile(LPCSTR, LPCSTR);

!#endif /* WIN32 */

Section('SocketTools Encode/Decode')

        Module('uucode32.dll')
            DecodeBase64(LPBYTE, Signed, LPBYTE, Signed, LPINT, LPINT), Signed, Pascal
            EncodeBase64(LPBYTE, Signed, LPBYTE, Signed, LPINT, LPINT, LPINT), Signed, Pascal
            EncodeBase64Done(LPINT, Signed, LPBYTE, Signed), Signed, Pascal
            Compile('***', _WIDTH32_ )
                DecodeFile(*CString, *CString), BOOL, Raw, Pascal, Name('DecodeFileA')
                EncodeFile(*CString, *CString), BOOL, Raw, Pascal, Name('EncodeFileA')
                DecodeBase64File(*CString, *CString), BOOL, Raw, Pascal, Name('DecodeBase64FileA')
                EncodeBase64File(*CString, *CString), BOOL, Raw, Pascal, Name('EncodeBase64FileA')
                DecodeQuotedFile(*CString, *CString), BOOL, Raw, Pascal, Name('DecodeQuotedFileA')
            ***
            Omit('***', _WIDTH32_ )
                DecodeFile(*CString, *CString), BOOL, Raw, Pascal
                EncodeFile(*CString, *CString), BOOL, Raw, Pascal
                DecodeBase64File(*CString, *CString), BOOL, Raw, Pascal
                EncodeBase64File(*CString, *CString), BOOL, Raw, Pascal
                DecodeQuotedFile(*CString, *CString), BOOL, Raw, Pascal
            ***
        end   ! Module('SocketTools encoding and decoding libraries')

!/*************************************************************************
! *
! * This section contains the prototypes for the SocketTools
! * Whois client libraries CSWHOL16.DLL and CSWHOL32.DLL
! *
! ************************************************************************/

!PUBLIC int WINAPI WhoisDisconnect(HCLIENT);
!PUBLIC int WINAPI WhoisAsyncNotify(HCLIENT, HWND, UINT);
!PUBLIC int WINAPI WhoisRead(HCLIENT, LPBYTE, int);
!PUBLIC int WINAPI WhoisCancel(HCLIENT);
!PUBLIC int WINAPI WhoisGetTimeout(HCLIENT);
!PUBLIC int WINAPI WhoisSetTimeout(HCLIENT, int);
!PUBLIC BOOL WINAPI WhoisIsBlocking(HCLIENT);
!PUBLIC VOID WINAPI WhoisSetLastError(int);
!PUBLIC int WINAPI WhoisGetLastError(VOID);
!PUBLIC SOCKET WINAPI WhoisGetSocket(HCLIENT);
!PUBLIC VOID WINAPI WhoisUninitialize(VOID);

!#ifdef WIN32
!PUBLIC BOOL WINAPI WhoisInitializeW(LPCWSTR, DWORD);
!PUBLIC BOOL WINAPI WhoisInitializeA(LPCSTR, DWORD);
!#ifdef UNICODE
!#define WhoisInitialize WhoisInitializeW
!#else
!#define WhoisInitialize WhoisInitializeA
!#endif

!PUBLIC HCLIENT WINAPI WhoisAsyncConnectW(LPCWSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI WhoisAsyncConnectA(LPCSTR, UINT, UINT, HWND, UINT);
!#ifdef UNICODE
!#define WhoisAsyncConnect WhoisAsyncConnectW
!#else
!#define WhoisAsyncConnect WhoisAsyncConnectA
!#endif

!PUBLIC HCLIENT WINAPI WhoisConnectW(LPCWSTR, UINT, UINT);
!PUBLIC HCLIENT WINAPI WhoisConnectA(LPCSTR, UINT, UINT);
!#ifdef UNICODE
!#define WhoisConnect WhoisConnectW
!#else
!#define WhoisConnect WhoisConnectA
!#endif

!PUBLIC int WINAPI WhoisSearchW(HCLIENT, LPCWSTR, UINT);
!PUBLIC int WINAPI WhoisSearchA(HCLIENT, LPCSTR, UINT);
!#ifdef UNICODE
!#define WhoisSearch WhoisSearchW
!#else
!#define WhoisSearch WhoisSearchA
!#endif

!PUBLIC int WINAPI WhoisGetErrorStringW(int, LPWSTR, int);
!PUBLIC int WINAPI WhoisGetErrorStringA(int, LPSTR, int);
!#ifdef UNICODE
!#define WhoisGetErrorString WhoisGetErrorStringW
!#else
!#define WhoisGetErrorString WhoisGetErrorStringA
!#endif

!#else /* !WIN32 */

!PUBLIC BOOL WINAPI WhoisInitialize(LPCSTR, DWORD);
!PUBLIC HCLIENT WINAPI WhoisAsyncConnect(LPCSTR, UINT, UINT, HWND, UINT);
!PUBLIC HCLIENT WINAPI WhoisConnect(LPCSTR, UINT, UINT);
!PUBLIC int WINAPI WhoisSearch(HCLIENT, LPCSTR, UINT);
!PUBLIC int WINAPI WhoisGetErrorString(int, LPSTR, int);

!#endif /* WIN32 */

Section('SocketTools Whois')

        Module('cswhol32.dll')
            WhoisDisconnect(HCLIENT), Signed, Pascal
            WhoisAsyncNotify(HCLIENT, HWND, Unsigned), Signed, Pascal
            WhoisRead(HCLIENT, LPBYTE, Signed), Signed, Pascal
            WhoisCancel(HCLIENT), Signed, Pascal
            WhoisGetTimeout(HCLIENT), Signed, Pascal
            WhoisSetTimeout(HCLIENT, Signed), Signed, Pascal
            WhoisIsBlocking(HCLIENT), BOOL, Pascal
            WhoisSetLastError(Signed), Pascal
            WhoisGetLastError(), Signed, Pascal
            WhoisGetSocket(HCLIENT), Socket, Pascal
            WhoisUninitialize(), Pascal
            Compile('***', _WIDTH32_ )
                WhoisInitialize(*CString, DWORD), BOOL, Raw, Pascal, Name('WhoisInitializeA')
                WhoisAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal, Name('WhoisAsyncConnectA')
                WhoisConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal, Name('WhoisConnectA')
                WhoisSearch(HCLIENT, *CString, Unsigned), Signed, Raw, Pascal, Name('WhoisSearchA')
                WhoisGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal, Name('WhoisGetErrorStringA')
            ***
            Omit('***', _WIDTH32_ )
                WhoisInitialize(*CString, DWORD), BOOL, Raw, Pascal
                WhoisAsyncConnect(*CString, Unsigned, Unsigned, HWND, Unsigned), HCLIENT, Raw, Pascal
                WhoisConnect(*CString, Unsigned, Unsigned), HCLIENT, Raw, Pascal
                WhoisSearch(HCLIENT, *CString, Unsigned), Signed, Raw, Pascal
                WhoisGetErrorString(Signed, *CString, Signed), Signed, Raw, Pascal
            ***
        end ! Module('the SocketTools Whois client libraries')
    end ! Map

!#ifdef __cplusplus
!}
!#endif
!#endif /* RC_INVOKED */
!#endif /* __MKTYPLIB__ */
!#endif /* _CSTOOLS_CSPROTO_H */

